#ifndef __PCX_H__
#define __PCX_H__

#include "defines.h"

typedef struct PCX
	{
		u8 * data;
		int width;
		int height;
		struct
			{
				u8 r,g,b;
			} pal[256];
	} PCX;

int PCX_Load ( PCX *, u8 *, int );
void PCX_Free ( PCX * );

#endif

