/* config.h
 * Copyright (c)2002 by Christian Nowak
 */

#ifndef __CONFIG_H__
#define __CONFIG_H__

class Config {
  
public:
  Config();
  ~Config();
  void destroy();
  int getValue(const char *var, int type);
  int load(const char *);
  int getContentsVal(const char *, int);
  int check();
  bool isLoaded();

protected:
  const char *fname;
  void *configFile;
  int configFileSize;

private:
  int splitoption(char *line, char *opt1, char *opt2);
};
/*
typedef struct config {

    const char *fname;
    void *configFile;
    int configFileSize;
} config;

int getConfigValue(config *c, const char * var, int type);
void destroyConfig(config *c);
int loadConfig(config *, const char *);
int getContentsVal(const char *, int);
int checkConfig(config *);
*/
#endif
