#include "../defines.h"

#define ILLINST NULL
#define ILLL    1

int Z80_Length[256] =
  {
    /* 0x00 */ 1,
    /* 0x01 */ 3,
    /* 0x02 */ 1,
    /* 0x03 */ 1,
    /* 0x04 */ 1,
    /* 0x05 */ 1,
    /* 0x06 */ 2,
    /* 0x07 */ 1,
    /* 0x08 */ 1,
    /* 0x09 */ 1,
    /* 0x0a */ 1,
    /* 0x0b */ 1,
    /* 0x0c */ 1,
    /* 0x0d */ 1,
    /* 0x0e */ 2,
    /* 0x0f */ 1,
    /* 0x10 */ 2,
    /* 0x11 */ 3,
    /* 0x12 */ 1,
    /* 0x13 */ 1,
    /* 0x14 */ 1,
    /* 0x15 */ 1,
    /* 0x16 */ 2,
    /* 0x17 */ 1,
    /* 0x18 */ 2,
    /* 0x19 */ 1,
    /* 0x1a */ 1,
    /* 0x1b */ 1,
    /* 0x1c */ 1,
    /* 0x1d */ 1,
    /* 0x1e */ 2,
    /* 0x1f */ 1,
    /* 0x20 */ 2,
    /* 0x21 */ 3,
    /* 0x22 */ 3,
    /* 0x23 */ 1,
    /* 0x24 */ 1,
    /* 0x25 */ 1,
    /* 0x26 */ 2,
    /* 0x27 */ 1,
    /* 0x28 */ 2,
    /* 0x29 */ 1,
    /* 0x2a */ 3,
    /* 0x2b */ 1,
    /* 0x2c */ 1,
    /* 0x2d */ 1,
    /* 0x2e */ 2,
    /* 0x2f */ 1,
    /* 0x30 */ 2,
    /* 0x31 */ 3,
    /* 0x32 */ 3,
    /* 0x33 */ 1,
    /* 0x34 */ 1,
    /* 0x35 */ 1,
    /* 0x36 */ 2,
    /* 0x37 */ 1,
    /* 0x38 */ 2,
    /* 0x39 */ 1,
    /* 0x3a */ 3,
    /* 0x3b */ 1,
    /* 0x3c */ 1,
    /* 0x3d */ 1,
    /* 0x3e */ 2,
    /* 0x3f */ 1,
    /* 0x40 */ 1,
    /* 0x41 */ 1,
    /* 0x42 */ 1,
    /* 0x43 */ 1,
    /* 0x44 */ 1,
    /* 0x45 */ 1,
    /* 0x46 */ 1,
    /* 0x47 */ 1,
    /* 0x48 */ 1,
    /* 0x49 */ 1,
    /* 0x4a */ 1,
    /* 0x4b */ 1,
    /* 0x4c */ 1,
    /* 0x4d */ 1,
    /* 0x4e */ 1,
    /* 0x4f */ 1,
    /* 0x50 */ 1,
    /* 0x51 */ 1,
    /* 0x52 */ 1,
    /* 0x53 */ 1,
    /* 0x54 */ 1,
    /* 0x55 */ 1,
    /* 0x56 */ 1,
    /* 0x57 */ 1,
    /* 0x58 */ 1,
    /* 0x59 */ 1,
    /* 0x5a */ 1,
    /* 0x5b */ 1,
    /* 0x5c */ 1,
    /* 0x5d */ 1,
    /* 0x5e */ 1,
    /* 0x5f */ 1,
    /* 0x60 */ 1,
    /* 0x61 */ 1,
    /* 0x62 */ 1,
    /* 0x63 */ 1,
    /* 0x64 */ 1,
    /* 0x65 */ 1,
    /* 0x66 */ 1,
    /* 0x67 */ 1,
    /* 0x68 */ 1,
    /* 0x69 */ 1,
    /* 0x6a */ 1,
    /* 0x6b */ 1,
    /* 0x6c */ 1,
    /* 0x6d */ 1,
    /* 0x6e */ 1,
    /* 0x6f */ 1,
    /* 0x70 */ 1,
    /* 0x71 */ 1,
    /* 0x72 */ 1,
    /* 0x73 */ 1,
    /* 0x74 */ 1,
    /* 0x75 */ 1,
    /* 0x76 */ 1,
    /* 0x77 */ 1,
    /* 0x78 */ 1,
    /* 0x79 */ 1,
    /* 0x7a */ 1,
    /* 0x7b */ 1,
    /* 0x7c */ 1,
    /* 0x7d */ 1,
    /* 0x7e */ 1,
    /* 0x7f */ 1,
    /* 0x80 */ 1,
    /* 0x81 */ 1,
    /* 0x82 */ 1,
    /* 0x83 */ 1,
    /* 0x84 */ 1,
    /* 0x85 */ 1,
    /* 0x86 */ 1,
    /* 0x87 */ 1,
    /* 0x88 */ 1,
    /* 0x89 */ 1,
    /* 0x8a */ 1,
    /* 0x8b */ 1,
    /* 0x8c */ 1,
    /* 0x8d */ 1,
    /* 0x8e */ 1,
    /* 0x8f */ 1,
    /* 0x90 */ 1,
    /* 0x91 */ 1,
    /* 0x92 */ 1,
    /* 0x93 */ 1,
    /* 0x94 */ 1,
    /* 0x95 */ 1,
    /* 0x96 */ 1,
    /* 0x97 */ 1,
    /* 0x98 */ 1,
    /* 0x99 */ 1,
    /* 0x9a */ 1,
    /* 0x9b */ 1,
    /* 0x9c */ 1,
    /* 0x9d */ 1,
    /* 0x9e */ 1,
    /* 0x9f */ 1,
    /* 0xa0 */ 1,
    /* 0xa1 */ 1,
    /* 0xa2 */ 1,
    /* 0xa3 */ 1,
    /* 0xa4 */ 1,
    /* 0xa5 */ 1,
    /* 0xa6 */ 1,
    /* 0xa7 */ 1,
    /* 0xa8 */ 1,
    /* 0xa9 */ 1,
    /* 0xaa */ 1,
    /* 0xab */ 1,
    /* 0xac */ 1,
    /* 0xad */ 1,
    /* 0xae */ 1,
    /* 0xaf */ 1,
    /* 0xb0 */ 1,
    /* 0xb1 */ 1,
    /* 0xb2 */ 1,
    /* 0xb3 */ 1,
    /* 0xb4 */ 1,
    /* 0xb5 */ 1,
    /* 0xb6 */ 1,
    /* 0xb7 */ 1,
    /* 0xb8 */ 1,
    /* 0xb9 */ 1,
    /* 0xba */ 1,
    /* 0xbb */ 1,
    /* 0xbc */ 1,
    /* 0xbd */ 1,
    /* 0xbe */ 1,
    /* 0xbf */ 1,
    /* 0xc0 */ 1,
    /* 0xc1 */ 1,
    /* 0xc2 */ 3,
    /* 0xc3 */ 3,
    /* 0xc4 */ 3,
    /* 0xc5 */ 1,
    /* 0xc6 */ 2,
    /* 0xc7 */ 1,
    /* 0xc8 */ 1,
    /* 0xc9 */ 1,
    /* 0xca */ 3,
    /* 0xcb */ ILLL,
    /* 0xcc */ 3,
    /* 0xcd */ 3,
    /* 0xce */ 2,
    /* 0xcf */ 1,
    /* 0xd0 */ 1,
    /* 0xd1 */ 1,
    /* 0xd2 */ 3,
    /* 0xd3 */ 2,
    /* 0xd4 */ 3,
    /* 0xd5 */ 1,
    /* 0xd6 */ 2,
    /* 0xd7 */ 1,
    /* 0xd8 */ 1,
    /* 0xd9 */ 1,
    /* 0xda */ 3,
    /* 0xdb */ 2,
    /* 0xdc */ 3,
    /* 0xdd */ ILLL,
    /* 0xde */ 2,
    /* 0xdf */ 1,
    /* 0xe0 */ 1,
    /* 0xe1 */ 1,
    /* 0xe2 */ 3,
    /* 0xe3 */ 1,
    /* 0xe4 */ 3,
    /* 0xe5 */ 1,
    /* 0xe6 */ 2,
    /* 0xe7 */ 1,
    /* 0xe8 */ 1,
    /* 0xe9 */ 1,
    /* 0xea */ 3,
    /* 0xeb */ 1,
    /* 0xec */ 3,
    /* 0xed */ ILLL,
    /* 0xee */ 2,
    /* 0xef */ 1,
    /* 0xf0 */ 1,
    /* 0xf1 */ 1,
    /* 0xf2 */ 3,
    /* 0xf3 */ 1,
    /* 0xf4 */ 3,
    /* 0xf5 */ 1,
    /* 0xf6 */ 2,
    /* 0xf7 */ 1,
    /* 0xf8 */ 1,
    /* 0xf9 */ 1,
    /* 0xfa */ 3,
    /* 0xfb */ 1,
    /* 0xfc */ 3,
    /* 0xfd */ ILLL,
    /* 0xfe */ 2,
    /* 0xff */ 1
  };

int Z80_LengthCB[256] =
  {
    /* 0x00 */ 2,
    /* 0x01 */ 2,
    /* 0x02 */ 2,
    /* 0x03 */ 2,
    /* 0x04 */ 2,
    /* 0x05 */ 2,
    /* 0x06 */ 2,
    /* 0x07 */ 2,
    /* 0x08 */ 2,
    /* 0x09 */ 2,
    /* 0x0a */ 2,
    /* 0x0b */ 2,
    /* 0x0c */ 2,
    /* 0x0d */ 2,
    /* 0x0e */ 2,
    /* 0x0f */ 2,
    /* 0x10 */ 2,
    /* 0x11 */ 2,
    /* 0x12 */ 2,
    /* 0x13 */ 2,
    /* 0x14 */ 2,
    /* 0x15 */ 2,
    /* 0x16 */ 2,
    /* 0x17 */ 2,
    /* 0x18 */ 2,
    /* 0x19 */ 2,
    /* 0x1a */ 2,
    /* 0x1b */ 2,
    /* 0x1c */ 2,
    /* 0x1d */ 2,
    /* 0x1e */ 2,
    /* 0x1f */ 2,
    /* 0x20 */ 2,
    /* 0x21 */ 2,
    /* 0x22 */ 2,
    /* 0x23 */ 2,
    /* 0x24 */ 2,
    /* 0x25 */ 2,
    /* 0x26 */ 2,
    /* 0x27 */ 2,
    /* 0x28 */ 2,
    /* 0x29 */ 2,
    /* 0x2a */ 2,
    /* 0x2b */ 2,
    /* 0x2c */ 2,
    /* 0x2d */ 2,
    /* 0x2e */ 2,
    /* 0x2f */ 2,
    /* 0x30 */ ILLL,
    /* 0x31 */ ILLL,
    /* 0x32 */ ILLL,
    /* 0x33 */ ILLL,
    /* 0x34 */ ILLL,
    /* 0x35 */ ILLL,
    /* 0x36 */ ILLL,
    /* 0x37 */ ILLL,
    /* 0x38 */ 2,
    /* 0x39 */ 2,
    /* 0x3a */ 2,
    /* 0x3b */ 2,
    /* 0x3c */ 2,
    /* 0x3d */ 2,
    /* 0x3e */ 2,
    /* 0x3f */ 2,
    /* 0x40 */ 2,
    /* 0x41 */ 2,
    /* 0x42 */ 2,
    /* 0x43 */ 2,
    /* 0x44 */ 2,
    /* 0x45 */ 2,
    /* 0x46 */ 2,
    /* 0x47 */ 2,
    /* 0x48 */ 2,
    /* 0x49 */ 2,
    /* 0x4a */ 2,
    /* 0x4b */ 2,
    /* 0x4c */ 2,
    /* 0x4d */ 2,
    /* 0x4e */ 2,
    /* 0x4f */ 2,
    /* 0x50 */ 2,
    /* 0x51 */ 2,
    /* 0x52 */ 2,
    /* 0x53 */ 2,
    /* 0x54 */ 2,
    /* 0x55 */ 2,
    /* 0x56 */ 2,
    /* 0x57 */ 2,
    /* 0x58 */ 2,
    /* 0x59 */ 2,
    /* 0x5a */ 2,
    /* 0x5b */ 2,
    /* 0x5c */ 2,
    /* 0x5d */ 2,
    /* 0x5e */ 2,
    /* 0x5f */ 2,
    /* 0x60 */ 2,
    /* 0x61 */ 2,
    /* 0x62 */ 2,
    /* 0x63 */ 2,
    /* 0x64 */ 2,
    /* 0x65 */ 2,
    /* 0x66 */ 2,
    /* 0x67 */ 2,
    /* 0x68 */ 2,
    /* 0x69 */ 2,
    /* 0x6a */ 2,
    /* 0x6b */ 2,
    /* 0x6c */ 2,
    /* 0x6d */ 2,
    /* 0x6e */ 2,
    /* 0x6f */ 2,
    /* 0x70 */ 2,
    /* 0x71 */ 2,
    /* 0x72 */ 2,
    /* 0x73 */ 2,
    /* 0x74 */ 2,
    /* 0x75 */ 2,
    /* 0x76 */ 2,
    /* 0x77 */ 2,
    /* 0x78 */ 2,
    /* 0x79 */ 2,
    /* 0x7a */ 2,
    /* 0x7b */ 2,
    /* 0x7c */ 2,
    /* 0x7d */ 2,
    /* 0x7e */ 2,
    /* 0x7f */ 2,
    /* 0x80 */ 2,
    /* 0x81 */ 2,
    /* 0x82 */ 2,
    /* 0x83 */ 2,
    /* 0x84 */ 2,
    /* 0x85 */ 2,
    /* 0x86 */ 2,
    /* 0x87 */ 2,
    /* 0x88 */ 2,
    /* 0x89 */ 2,
    /* 0x8a */ 2,
    /* 0x8b */ 2,
    /* 0x8c */ 2,
    /* 0x8d */ 2,
    /* 0x8e */ 2,
    /* 0x8f */ 2,
    /* 0x90 */ 2,
    /* 0x91 */ 2,
    /* 0x92 */ 2,
    /* 0x93 */ 2,
    /* 0x94 */ 2,
    /* 0x95 */ 2,
    /* 0x96 */ 2,
    /* 0x97 */ 2,
    /* 0x98 */ 2,
    /* 0x99 */ 2,
    /* 0x9a */ 2,
    /* 0x9b */ 2,
    /* 0x9c */ 2,
    /* 0x9d */ 2,
    /* 0x9e */ 2,
    /* 0x9f */ 2,
    /* 0xa0 */ 2,
    /* 0xa1 */ 2,
    /* 0xa2 */ 2,
    /* 0xa3 */ 2,
    /* 0xa4 */ 2,
    /* 0xa5 */ 2,
    /* 0xa6 */ 2,
    /* 0xa7 */ 2,
    /* 0xa8 */ 2,
    /* 0xa9 */ 2,
    /* 0xaa */ 2,
    /* 0xab */ 2,
    /* 0xac */ 2,
    /* 0xad */ 2,
    /* 0xae */ 2,
    /* 0xaf */ 2,
    /* 0xb0 */ 2,
    /* 0xb1 */ 2,
    /* 0xb2 */ 2,
    /* 0xb3 */ 2,
    /* 0xb4 */ 2,
    /* 0xb5 */ 2,
    /* 0xb6 */ 2,
    /* 0xb7 */ 2,
    /* 0xb8 */ 2,
    /* 0xb9 */ 2,
    /* 0xba */ 2,
    /* 0xbb */ 2,
    /* 0xbc */ 2,
    /* 0xbd */ 2,
    /* 0xbe */ 2,
    /* 0xbf */ 2,
    /* 0xc0 */ 2,
    /* 0xc1 */ 2,
    /* 0xc2 */ 2,
    /* 0xc3 */ 2,
    /* 0xc4 */ 2,
    /* 0xc5 */ 2,
    /* 0xc6 */ 2,
    /* 0xc7 */ 2,
    /* 0xc8 */ 2,
    /* 0xc9 */ 2,
    /* 0xca */ 2,
    /* 0xcb */ 2,
    /* 0xcc */ 2,
    /* 0xcd */ 2,
    /* 0xce */ 2,
    /* 0xcf */ 2,
    /* 0xd0 */ 2,
    /* 0xd1 */ 2,
    /* 0xd2 */ 2,
    /* 0xd3 */ 2,
    /* 0xd4 */ 2,
    /* 0xd5 */ 2,
    /* 0xd6 */ 2,
    /* 0xd7 */ 2,
    /* 0xd8 */ 2,
    /* 0xd9 */ 2,
    /* 0xda */ 2,
    /* 0xdb */ 2,
    /* 0xdc */ 2,
    /* 0xdd */ 2,
    /* 0xde */ 2,
    /* 0xdf */ 2,
    /* 0xe0 */ 2,
    /* 0xe1 */ 2,
    /* 0xe2 */ 2,
    /* 0xe3 */ 2,
    /* 0xe4 */ 2,
    /* 0xe5 */ 2,
    /* 0xe6 */ 2,
    /* 0xe7 */ 2,
    /* 0xe8 */ 2,
    /* 0xe9 */ 2,
    /* 0xea */ 2,
    /* 0xeb */ 2,
    /* 0xec */ 2,
    /* 0xed */ 2,
    /* 0xee */ 2,
    /* 0xef */ 2,
    /* 0xf0 */ 2,
    /* 0xf1 */ 2,
    /* 0xf2 */ 2,
    /* 0xf3 */ 2,
    /* 0xf4 */ 2,
    /* 0xf5 */ 2,
    /* 0xf6 */ 2,
    /* 0xf7 */ 2,
    /* 0xf8 */ 2,
    /* 0xf9 */ 2,
    /* 0xfa */ 2,
    /* 0xfb */ 2,
    /* 0xfc */ 2,
    /* 0xfd */ 2,
    /* 0xfe */ 2,
    /* 0xff */ 2
  };

int Z80_LengthFD[256] =
  {
    /* 0x00 */ ILLL,
    /* 0x01 */ ILLL,
    /* 0x02 */ 2,
    /* 0x03 */ ILLL,
    /* 0x04 */ ILLL,
    /* 0x05 */ ILLL,
    /* 0x06 */ ILLL,
    /* 0x07 */ ILLL,
    /* 0x08 */ ILLL,
    /* 0x09 */ 2,
    /* 0x0a */ 2,
    /* 0x0b */ ILLL,
    /* 0x0c */ ILLL,
    /* 0x0d */ ILLL,
    /* 0x0e */ ILLL,
    /* 0x0f */ ILLL,
    /* 0x10 */ ILLL,
    /* 0x11 */ ILLL,
    /* 0x12 */ ILLL,
    /* 0x13 */ ILLL,
    /* 0x14 */ ILLL,
    /* 0x15 */ ILLL,
    /* 0x16 */ ILLL,
    /* 0x17 */ ILLL,
    /* 0x18 */ ILLL,
    /* 0x19 */ 2,
    /* 0x1a */ ILLL,
    /* 0x1b */ ILLL,
    /* 0x1c */ ILLL,
    /* 0x1d */ ILLL,
    /* 0x1e */ ILLL,
    /* 0x1f */ ILLL,
    /* 0x20 */ ILLL,
    /* 0x21 */ 4,
    /* 0x22 */ 4,
    /* 0x23 */ 2,
    /* 0x24 */ ILLL,
    /* 0x25 */ ILLL,
    /* 0x26 */ 3,
    /* 0x27 */ ILLL,
    /* 0x28 */ ILLL,
    /* 0x29 */ 2,
    /* 0x2a */ 4,
    /* 0x2b */ 2,
    /* 0x2c */ ILLL,
    /* 0x2d */ 2,
    /* 0x2e */ 3,
    /* 0x2f */ ILLL,
    /* 0x30 */ ILLL,
    /* 0x31 */ ILLL,
    /* 0x32 */ ILLL,
    /* 0x33 */ ILLL,
    /* 0x34 */ 3,
    /* 0x35 */ 3,
    /* 0x36 */ 4,
    /* 0x37 */ ILLL,
    /* 0x38 */ ILLL,
    /* 0x39 */ 2,
    /* 0x3a */ ILLL,
    /* 0x3b */ ILLL,
    /* 0x3c */ ILLL,
    /* 0x3d */ ILLL,
    /* 0x3e */ ILLL,
    /* 0x3f */ ILLL,
    /* 0x40 */ ILLL,
    /* 0x41 */ ILLL,
    /* 0x42 */ ILLL,
    /* 0x43 */ ILLL,
    /* 0x44 */ ILLL,
    /* 0x45 */ 2,
    /* 0x46 */ 3,
    /* 0x47 */ ILLL,
    /* 0x48 */ ILLL,
    /* 0x49 */ ILLL,
    /* 0x4a */ ILLL,
    /* 0x4b */ ILLL,
    /* 0x4c */ ILLL,
    /* 0x4d */ 2,
    /* 0x4e */ 3,
    /* 0x4f */ ILLL,
    /* 0x50 */ ILLL,
    /* 0x51 */ ILLL,
    /* 0x52 */ ILLL,
    /* 0x53 */ ILLL,
    /* 0x54 */ 2,
    /* 0x55 */ 2,
    /* 0x56 */ 3,
    /* 0x57 */ ILLL,
    /* 0x58 */ ILLL,
    /* 0x59 */ ILLL,
    /* 0x5a */ ILLL,
    /* 0x5b */ ILLL,
    /* 0x5c */ ILLL,
    /* 0x5d */ 2,
    /* 0x5e */ 3,
    /* 0x5f */ ILLL,
    /* 0x60 */ 2,
    /* 0x61 */ 2,
    /* 0x62 */ 2,
    /* 0x63 */ 2,
    /* 0x64 */ 2,
    /* 0x65 */ 2,
    /* 0x66 */ 3,
    /* 0x67 */ 2,
    /* 0x68 */ 2,
    /* 0x69 */ 2,
    /* 0x6a */ 2,
    /* 0x6b */ 2,
    /* 0x6c */ 2,
    /* 0x6d */ 2,
    /* 0x6e */ 3,
    /* 0x6f */ 2,
    /* 0x70 */ 3,
    /* 0x71 */ 3,
    /* 0x72 */ 3,
    /* 0x73 */ 3,
    /* 0x74 */ 3,
    /* 0x75 */ 3,
    /* 0x76 */ ILLL,
    /* 0x77 */ 3,
    /* 0x78 */ ILLL,
    /* 0x79 */ ILLL,
    /* 0x7a */ ILLL,
    /* 0x7b */ ILLL,
    /* 0x7c */ 2,
    /* 0x7d */ 2,
    /* 0x7e */ 3,
    /* 0x7f */ ILLL,
    /* 0x80 */ ILLL,
    /* 0x81 */ ILLL,
    /* 0x82 */ ILLL,
    /* 0x83 */ ILLL,
    /* 0x84 */ ILLL,
    /* 0x85 */ 2,
    /* 0x86 */ 3,
    /* 0x87 */ ILLL,
    /* 0x88 */ ILLL,
    /* 0x89 */ ILLL,
    /* 0x8a */ ILLL,
    /* 0x8b */ ILLL,
    /* 0x8c */ ILLL,
    /* 0x8d */ 2,
    /* 0x8e */ 3,
    /* 0x8f */ ILLL,
    /* 0x90 */ ILLL,
    /* 0x91 */ ILLL,
    /* 0x92 */ ILLL,
    /* 0x93 */ ILLL,
    /* 0x94 */ ILLL,
    /* 0x95 */ ILLL,
    /* 0x96 */ 3,
    /* 0x97 */ ILLL,
    /* 0x98 */ ILLL,
    /* 0x99 */ ILLL,
    /* 0x9a */ ILLL,
    /* 0x9b */ ILLL,
    /* 0x9c */ 2,
    /* 0x9d */ ILLL,
    /* 0x9e */ 3,
    /* 0x9f */ ILLL,
    /* 0xa0 */ ILLL,
    /* 0xa1 */ ILLL,
    /* 0xa2 */ ILLL,
    /* 0xa3 */ ILLL,
    /* 0xa4 */ ILLL,
    /* 0xa5 */ ILLL,
    /* 0xa6 */ 3,
    /* 0xa7 */ ILLL,
    /* 0xa8 */ ILLL,
    /* 0xa9 */ ILLL,
    /* 0xaa */ ILLL,
    /* 0xab */ ILLL,
    /* 0xac */ ILLL,
    /* 0xad */ 2,
    /* 0xae */ 3,
    /* 0xaf */ ILLL,
    /* 0xb0 */ ILLL,
    /* 0xb1 */ ILLL,
    /* 0xb2 */ ILLL,
    /* 0xb3 */ ILLL,
    /* 0xb4 */ ILLL,
    /* 0xb5 */ 2,
    /* 0xb6 */ 3,
    /* 0xb7 */ ILLL,
    /* 0xb8 */ ILLL,
    /* 0xb9 */ ILLL,
    /* 0xba */ ILLL,
    /* 0xbb */ ILLL,
    /* 0xbc */ ILLL,
    /* 0xbd */ 2,
    /* 0xbe */ 3,
    /* 0xbf */ ILLL,
    /* 0xc0 */ ILLL,
    /* 0xc1 */ ILLL,
    /* 0xc2 */ ILLL,
    /* 0xc3 */ ILLL,
    /* 0xc4 */ ILLL,
    /* 0xc5 */ ILLL,
    /* 0xc6 */ ILLL,
    /* 0xc7 */ ILLL,
    /* 0xc8 */ ILLL,
    /* 0xc9 */ ILLL,
    /* 0xca */ ILLL,
    /* 0xcb */ ILLL,
    /* 0xcc */ ILLL,
    /* 0xcd */ ILLL,
    /* 0xce */ ILLL,
    /* 0xcf */ ILLL,
    /* 0xd0 */ ILLL,
    /* 0xd1 */ ILLL,
    /* 0xd2 */ ILLL,
    /* 0xd3 */ ILLL,
    /* 0xd4 */ ILLL,
    /* 0xd5 */ ILLL,
    /* 0xd6 */ ILLL,
    /* 0xd7 */ ILLL,
    /* 0xd8 */ ILLL,
    /* 0xd9 */ ILLL,
    /* 0xda */ ILLL,
    /* 0xdb */ ILLL,
    /* 0xdc */ ILLL,
    /* 0xdd */ ILLL,
    /* 0xde */ ILLL,
    /* 0xdf */ ILLL,
    /* 0xe0 */ ILLL,
    /* 0xe1 */ 2,
    /* 0xe2 */ ILLL,
    /* 0xe3 */ 2,
    /* 0xe4 */ ILLL,
    /* 0xe5 */ 2,
    /* 0xe6 */ ILLL,
    /* 0xe7 */ ILLL,
    /* 0xe8 */ ILLL,
    /* 0xe9 */ 2,
    /* 0xea */ ILLL,
    /* 0xeb */ 2,
    /* 0xec */ ILLL,
    /* 0xed */ ILLL,
    /* 0xee */ ILLL,
    /* 0xef */ ILLL,
    /* 0xf0 */ ILLL,
    /* 0xf1 */ ILLL,
    /* 0xf2 */ ILLL,
    /* 0xf3 */ ILLL,
    /* 0xf4 */ ILLL,
    /* 0xf5 */ ILLL,
    /* 0xf6 */ ILLL,
    /* 0xf7 */ ILLL,
    /* 0xf8 */ ILLL,
    /* 0xf9 */ 2,
    /* 0xfa */ ILLL,
    /* 0xfb */ ILLL,
    /* 0xfc */ ILLL,
    /* 0xfd */ ILLL,
    /* 0xfe */ ILLL,
    /* 0xff */ ILLL
  };

int Z80_LengthDD[256] =
  {
    /* 0x00 */ ILLL,
    /* 0x01 */ ILLL,
    /* 0x02 */ ILLL,
    /* 0x03 */ 2,
    /* 0x04 */ ILLL,
    /* 0x05 */ ILLL,
    /* 0x06 */ ILLL,
    /* 0x07 */ ILLL,
    /* 0x08 */ ILLL,
    /* 0x09 */ 2,
    /* 0x0a */ ILLL,
    /* 0x0b */ ILLL,
    /* 0x0c */ ILLL,
    /* 0x0d */ ILLL,
    /* 0x0e */ ILLL,
    /* 0x0f */ ILLL,
    /* 0x10 */ ILLL,
    /* 0x11 */ ILLL,
    /* 0x12 */ ILLL,
    /* 0x13 */ ILLL,
    /* 0x14 */ ILLL,
    /* 0x15 */ ILLL,
    /* 0x16 */ ILLL,
    /* 0x17 */ ILLL,
    /* 0x18 */ ILLL,
    /* 0x19 */ 2,
    /* 0x1a */ ILLL,
    /* 0x1b */ ILLL,
    /* 0x1c */ ILLL,
    /* 0x1d */ ILLL,
    /* 0x1e */ ILLL,
    /* 0x1f */ ILLL,
    /* 0x20 */ ILLL,
    /* 0x21 */ 4,
    /* 0x22 */ 4,
    /* 0x23 */ 2,
    /* 0x24 */ 2,
    /* 0x25 */ ILLL,
    /* 0x26 */ 3,
    /* 0x27 */ ILLL,
    /* 0x28 */ ILLL,
    /* 0x29 */ 2,
    /* 0x2a */ 4,
    /* 0x2b */ 2,
    /* 0x2c */ ILLL,
    /* 0x2d */ ILLL,
    /* 0x2e */ ILLL,
    /* 0x2f */ ILLL,
    /* 0x30 */ ILLL,
    /* 0x31 */ ILLL,
    /* 0x32 */ ILLL,
    /* 0x33 */ ILLL,
    /* 0x34 */ 3,
    /* 0x35 */ 3,
    /* 0x36 */ 4,
    /* 0x37 */ ILLL,
    /* 0x38 */ ILLL,
    /* 0x39 */ 2,
    /* 0x3a */ ILLL,
    /* 0x3b */ ILLL,
    /* 0x3c */ ILLL,
    /* 0x3d */ ILLL,
    /* 0x3e */ ILLL,
    /* 0x3f */ ILLL,
    /* 0x40 */ ILLL,
    /* 0x41 */ ILLL,
    /* 0x42 */ ILLL,
    /* 0x43 */ ILLL,
    /* 0x44 */ ILLL,
    /* 0x45 */ 2,
    /* 0x46 */ 3,
    /* 0x47 */ ILLL,
    /* 0x48 */ ILLL,
    /* 0x49 */ ILLL,
    /* 0x4a */ ILLL,
    /* 0x4b */ ILLL,
    /* 0x4c */ ILLL,
    /* 0x4d */ 2,
    /* 0x4e */ 3,
    /* 0x4f */ ILLL,
    /* 0x50 */ ILLL,
    /* 0x51 */ ILLL,
    /* 0x52 */ ILLL,
    /* 0x53 */ ILLL,
    /* 0x54 */ 2,
    /* 0x55 */ 2,
    /* 0x56 */ 3,
    /* 0x57 */ ILLL,
    /* 0x58 */ ILLL,
    /* 0x59 */ ILLL,
    /* 0x5a */ ILLL,
    /* 0x5b */ ILLL,
    /* 0x5c */ ILLL,
    /* 0x5d */ 2,
    /* 0x5e */ 3,
    /* 0x5f */ ILLL,
    /* 0x60 */ 2,
    /* 0x61 */ ILLL,
    /* 0x62 */ 2,
    /* 0x63 */ ILLL,
    /* 0x64 */ ILLL,
    /* 0x65 */ ILLL,
    /* 0x66 */ 3,
    /* 0x67 */ 2,
    /* 0x68 */ 2,
    /* 0x69 */ ILLL,
    /* 0x6a */ ILLL,
    /* 0x6b */ 2,
    /* 0x6c */ ILLL,
    /* 0x6d */ ILLL,
    /* 0x6e */ 3,
    /* 0x6f */ 2,
    /* 0x70 */ 3,
    /* 0x71 */ 3,
    /* 0x72 */ 3,
    /* 0x73 */ 3,
    /* 0x74 */ 3,
    /* 0x75 */ 3,
    /* 0x76 */ ILLL,
    /* 0x77 */ 3,
    /* 0x78 */ ILLL,
    /* 0x79 */ ILLL,
    /* 0x7a */ ILLL,
    /* 0x7b */ ILLL,
    /* 0x7c */ 2,
    /* 0x7d */ 2,
    /* 0x7e */ 3,
    /* 0x7f */ ILLL,
    /* 0x80 */ ILLL,
    /* 0x81 */ ILLL,
    /* 0x82 */ ILLL,
    /* 0x83 */ ILLL,
    /* 0x84 */ ILLL,
    /* 0x85 */ 2,
    /* 0x86 */ 3,
    /* 0x87 */ ILLL,
    /* 0x88 */ ILLL,
    /* 0x89 */ ILLL,
    /* 0x8a */ ILLL,
    /* 0x8b */ ILLL,
    /* 0x8c */ 2,
    /* 0x8d */ 2,
    /* 0x8e */ 3,
    /* 0x8f */ ILLL,
    /* 0x90 */ ILLL,
    /* 0x91 */ ILLL,
    /* 0x92 */ ILLL,
    /* 0x93 */ ILLL,
    /* 0x94 */ ILLL,
    /* 0x95 */ 2,
    /* 0x96 */ 3,
    /* 0x97 */ ILLL,
    /* 0x98 */ ILLL,
    /* 0x99 */ ILLL,
    /* 0x9a */ ILLL,
    /* 0x9b */ ILLL,
    /* 0x9c */ ILLL,
    /* 0x9d */ ILLL,
    /* 0x9e */ 3,
    /* 0x9f */ ILLL,
    /* 0xa0 */ ILLL,
    /* 0xa1 */ ILLL,
    /* 0xa2 */ ILLL,
    /* 0xa3 */ ILLL,
    /* 0xa4 */ ILLL,
    /* 0xa5 */ ILLL,
    /* 0xa6 */ 3,
    /* 0xa7 */ ILLL,
    /* 0xa8 */ ILLL,
    /* 0xa9 */ ILLL,
    /* 0xaa */ ILLL,
    /* 0xab */ ILLL,
    /* 0xac */ ILLL,
    /* 0xad */ 2,
    /* 0xae */ 3,
    /* 0xaf */ ILLL,
    /* 0xb0 */ ILLL,
    /* 0xb1 */ ILLL,
    /* 0xb2 */ ILLL,
    /* 0xb3 */ ILLL,
    /* 0xb4 */ ILLL,
    /* 0xb5 */ 2,
    /* 0xb6 */ 3,
    /* 0xb7 */ ILLL,
    /* 0xb8 */ ILLL,
    /* 0xb9 */ ILLL,
    /* 0xba */ ILLL,
    /* 0xbb */ ILLL,
    /* 0xbc */ ILLL,
    /* 0xbd */ 2,
    /* 0xbe */ 3,
    /* 0xbf */ ILLL,
    /* 0xc0 */ ILLL,
    /* 0xc1 */ ILLL,
    /* 0xc2 */ ILLL,
    /* 0xc3 */ ILLL,
    /* 0xc4 */ ILLL,
    /* 0xc5 */ ILLL,
    /* 0xc6 */ ILLL,
    /* 0xc7 */ 2,
    /* 0xc8 */ ILLL,
    /* 0xc9 */ ILLL,
    /* 0xca */ ILLL,
    /* 0xcb */ ILLL,
    /* 0xcc */ ILLL,
    /* 0xcd */ ILLL,
    /* 0xce */ ILLL,
    /* 0xcf */ 2,
    /* 0xd0 */ ILLL,
    /* 0xd1 */ ILLL,
    /* 0xd2 */ ILLL,
    /* 0xd3 */ ILLL,
    /* 0xd4 */ ILLL,
    /* 0xd5 */ ILLL,
    /* 0xd6 */ ILLL,
    /* 0xd7 */ 2,
    /* 0xd8 */ ILLL,
    /* 0xd9 */ ILLL,
    /* 0xda */ ILLL,
    /* 0xdb */ ILLL,
    /* 0xdc */ ILLL,
    /* 0xdd */ ILLL,
    /* 0xde */ ILLL,
    /* 0xdf */ 2,
    /* 0xe0 */ ILLL,
    /* 0xe1 */ 2,
    /* 0xe2 */ ILLL,
    /* 0xe3 */ 2,
    /* 0xe4 */ ILLL,
    /* 0xe5 */ 2,
    /* 0xe6 */ ILLL,
    /* 0xe7 */ 2,
    /* 0xe8 */ ILLL,
    /* 0xe9 */ 2,
    /* 0xea */ ILLL,
    /* 0xeb */ 2,
    /* 0xec */ ILLL,
    /* 0xed */ ILLL,
    /* 0xee */ ILLL,
    /* 0xef */ 2,
    /* 0xf0 */ ILLL,
    /* 0xf1 */ ILLL,
    /* 0xf2 */ ILLL,
    /* 0xf3 */ ILLL,
    /* 0xf4 */ ILLL,
    /* 0xf5 */ ILLL,
    /* 0xf6 */ ILLL,
    /* 0xf7 */ 2,
    /* 0xf8 */ ILLL,
    /* 0xf9 */ 2,
    /* 0xfa */ ILLL,
    /* 0xfb */ ILLL,
    /* 0xfc */ ILLL,
    /* 0xfd */ ILLL,
    /* 0xfe */ ILLL,
    /* 0xff */ 2
  };

int Z80_LengthED[256] =
  {
    /* 0x00 */ ILLL,
    /* 0x01 */ ILLL,
    /* 0x02 */ ILLL,
    /* 0x03 */ ILLL,
    /* 0x04 */ ILLL,
    /* 0x05 */ ILLL,
    /* 0x06 */ ILLL,
    /* 0x07 */ ILLL,
    /* 0x08 */ ILLL,
    /* 0x09 */ ILLL,
    /* 0x0a */ ILLL,
    /* 0x0b */ ILLL,
    /* 0x0c */ ILLL,
    /* 0x0d */ ILLL,
    /* 0x0e */ ILLL,
    /* 0x0f */ ILLL,
    /* 0x10 */ ILLL,
    /* 0x11 */ ILLL,
    /* 0x12 */ ILLL,
    /* 0x13 */ ILLL,
    /* 0x14 */ ILLL,
    /* 0x15 */ ILLL,
    /* 0x16 */ ILLL,
    /* 0x17 */ ILLL,
    /* 0x18 */ ILLL,
    /* 0x19 */ ILLL,
    /* 0x1a */ ILLL,
    /* 0x1b */ ILLL,
    /* 0x1c */ ILLL,
    /* 0x1d */ ILLL,
    /* 0x1e */ ILLL,
    /* 0x1f */ ILLL,
    /* 0x20 */ ILLL,
    /* 0x21 */ ILLL,
    /* 0x22 */ ILLL,
    /* 0x23 */ ILLL,
    /* 0x24 */ ILLL,
    /* 0x25 */ ILLL,
    /* 0x26 */ ILLL,
    /* 0x27 */ ILLL,
    /* 0x28 */ ILLL,
    /* 0x29 */ ILLL,
    /* 0x2a */ ILLL,
    /* 0x2b */ ILLL,
    /* 0x2c */ ILLL,
    /* 0x2d */ ILLL,
    /* 0x2e */ ILLL,
    /* 0x2f */ ILLL,
    /* 0x30 */ ILLL,
    /* 0x31 */ ILLL,
    /* 0x32 */ ILLL,
    /* 0x33 */ ILLL,
    /* 0x34 */ ILLL,
    /* 0x35 */ ILLL,
    /* 0x36 */ ILLL,
    /* 0x37 */ ILLL,
    /* 0x38 */ ILLL,
    /* 0x39 */ ILLL,
    /* 0x3a */ ILLL,
    /* 0x3b */ ILLL,
    /* 0x3c */ ILLL,
    /* 0x3d */ ILLL,
    /* 0x3e */ ILLL,
    /* 0x3f */ ILLL,
    /* 0x40 */ 2,
    /* 0x41 */ 2,
    /* 0x42 */ 2,
    /* 0x43 */ 4,
    /* 0x44 */ 2,
    /* 0x45 */ 2,
    /* 0x46 */ 2,
    /* 0x47 */ 2,
    /* 0x48 */ 2,
    /* 0x49 */ 2,
    /* 0x4a */ 2,
    /* 0x4b */ 4,
    /* 0x4c */ ILLL,
    /* 0x4d */ 2,
    /* 0x4e */ ILLL,
    /* 0x4f */ 2,
    /* 0x50 */ 2,
    /* 0x51 */ 2,
    /* 0x52 */ 2,
    /* 0x53 */ 4,
    /* 0x54 */ ILLL,
    /* 0x55 */ ILLL,
    /* 0x56 */ 2,
    /* 0x57 */ 2,
    /* 0x58 */ 2,
    /* 0x59 */ 2,
    /* 0x5a */ 2,
    /* 0x5b */ 4,
    /* 0x5c */ ILLL,
    /* 0x5d */ ILLL,
    /* 0x5e */ 2,
    /* 0x5f */ 2,
    /* 0x60 */ 2,
    /* 0x61 */ 2,
    /* 0x62 */ 2,
    /* 0x63 */ 4,
    /* 0x64 */ ILLL,
    /* 0x65 */ ILLL,
    /* 0x66 */ ILLL,
    /* 0x67 */ 2,
    /* 0x68 */ 2,
    /* 0x69 */ 2,
    /* 0x6a */ 2,
    /* 0x6b */ 4,
    /* 0x6c */ ILLL,
    /* 0x6d */ ILLL,
    /* 0x6e */ ILLL,
    /* 0x6f */ 2,
    /* 0x70 */ 2,
    /* 0x71 */ ILLL,
    /* 0x72 */ 2,
    /* 0x73 */ 4,
    /* 0x74 */ ILLL,
    /* 0x75 */ ILLL,
    /* 0x76 */ ILLL,
    /* 0x77 */ ILLL,
    /* 0x78 */ 2,
    /* 0x79 */ 2,
    /* 0x7a */ 2,
    /* 0x7b */ 4,
    /* 0x7c */ ILLL,
    /* 0x7d */ ILLL,
    /* 0x7e */ ILLL,
    /* 0x7f */ ILLL,
    /* 0x80 */ ILLL,
    /* 0x81 */ ILLL,
    /* 0x82 */ ILLL,
    /* 0x83 */ ILLL,
    /* 0x84 */ ILLL,
    /* 0x85 */ ILLL,
    /* 0x86 */ ILLL,
    /* 0x87 */ ILLL,
    /* 0x88 */ ILLL,
    /* 0x89 */ ILLL,
    /* 0x8a */ ILLL,
    /* 0x8b */ ILLL,
    /* 0x8c */ ILLL,
    /* 0x8d */ ILLL,
    /* 0x8e */ ILLL,
    /* 0x8f */ ILLL,
    /* 0x90 */ ILLL,
    /* 0x91 */ ILLL,
    /* 0x92 */ ILLL,
    /* 0x93 */ ILLL,
    /* 0x94 */ ILLL,
    /* 0x95 */ ILLL,
    /* 0x96 */ ILLL,
    /* 0x97 */ ILLL,
    /* 0x98 */ ILLL,
    /* 0x99 */ ILLL,
    /* 0x9a */ ILLL,
    /* 0x9b */ ILLL,
    /* 0x9c */ ILLL,
    /* 0x9d */ ILLL,
    /* 0x9e */ ILLL,
    /* 0x9f */ ILLL,
    /* 0xa0 */ 2,
    /* 0xa1 */ 2,
    /* 0xa2 */ 2,
    /* 0xa3 */ 2,
    /* 0xa4 */ ILLL,
    /* 0xa5 */ ILLL,
    /* 0xa6 */ ILLL,
    /* 0xa7 */ ILLL,
    /* 0xa8 */ 2,
    /* 0xa9 */ 2,
    /* 0xaa */ 2,
    /* 0xab */ 2,
    /* 0xac */ ILLL,
    /* 0xad */ ILLL,
    /* 0xae */ ILLL,
    /* 0xaf */ ILLL,
    /* 0xb0 */ 2,
    /* 0xb1 */ 2,
    /* 0xb2 */ 2,
    /* 0xb3 */ 2,
    /* 0xb4 */ ILLL,
    /* 0xb5 */ ILLL,
    /* 0xb6 */ ILLL,
    /* 0xb7 */ ILLL,
    /* 0xb8 */ 2,
    /* 0xb9 */ 2,
    /* 0xba */ 2,
    /* 0xbb */ 2,
    /* 0xbc */ ILLL,
    /* 0xbd */ ILLL,
    /* 0xbe */ ILLL,
    /* 0xbf */ ILLL,
    /* 0xc0 */ ILLL,
    /* 0xc1 */ ILLL,
    /* 0xc2 */ ILLL,
    /* 0xc3 */ ILLL,
    /* 0xc4 */ ILLL,
    /* 0xc5 */ ILLL,
    /* 0xc6 */ ILLL,
    /* 0xc7 */ ILLL,
    /* 0xc8 */ ILLL,
    /* 0xc9 */ ILLL,
    /* 0xca */ ILLL,
    /* 0xcb */ ILLL,
    /* 0xcc */ ILLL,
    /* 0xcd */ ILLL,
    /* 0xce */ ILLL,
    /* 0xcf */ ILLL,
    /* 0xd0 */ ILLL,
    /* 0xd1 */ ILLL,
    /* 0xd2 */ ILLL,
    /* 0xd3 */ ILLL,
    /* 0xd4 */ ILLL,
    /* 0xd5 */ ILLL,
    /* 0xd6 */ ILLL,
    /* 0xd7 */ ILLL,
    /* 0xd8 */ ILLL,
    /* 0xd9 */ ILLL,
    /* 0xda */ ILLL,
    /* 0xdb */ ILLL,
    /* 0xdc */ ILLL,
    /* 0xdd */ ILLL,
    /* 0xde */ ILLL,
    /* 0xdf */ ILLL,
    /* 0xe0 */ ILLL,
    /* 0xe1 */ ILLL,
    /* 0xe2 */ ILLL,
    /* 0xe3 */ ILLL,
    /* 0xe4 */ ILLL,
    /* 0xe5 */ ILLL,
    /* 0xe6 */ ILLL,
    /* 0xe7 */ ILLL,
    /* 0xe8 */ ILLL,
    /* 0xe9 */ ILLL,
    /* 0xea */ ILLL,
    /* 0xeb */ ILLL,
    /* 0xec */ ILLL,
    /* 0xed */ ILLL,
    /* 0xee */ ILLL,
    /* 0xef */ ILLL,
    /* 0xf0 */ ILLL,
    /* 0xf1 */ ILLL,
    /* 0xf2 */ ILLL,
    /* 0xf3 */ ILLL,
    /* 0xf4 */ ILLL,
    /* 0xf5 */ ILLL,
    /* 0xf6 */ ILLL,
    /* 0xf7 */ ILLL,
    /* 0xf8 */ ILLL,
    /* 0xf9 */ ILLL,
    /* 0xfa */ ILLL,
    /* 0xfb */ ILLL,
    /* 0xfc */ ILLL,
    /* 0xfd */ ILLL,
    /* 0xfe */ ILLL,
    /* 0xff */ ILLL
  };

int Z80_LengthFDCB[256] =
  {
    /* 0x00 */ ILLL,
    /* 0x01 */ ILLL,
    /* 0x02 */ ILLL,
    /* 0x03 */ ILLL,
    /* 0x04 */ ILLL,
    /* 0x05 */ ILLL,
    /* 0x06 */ 4,
    /* 0x07 */ ILLL,
    /* 0x08 */ ILLL,
    /* 0x09 */ ILLL,
    /* 0x0a */ ILLL,
    /* 0x0b */ ILLL,
    /* 0x0c */ ILLL,
    /* 0x0d */ ILLL,
    /* 0x0e */ 4,
    /* 0x0f */ ILLL,
    /* 0x10 */ ILLL,
    /* 0x11 */ ILLL,
    /* 0x12 */ ILLL,
    /* 0x13 */ ILLL,
    /* 0x14 */ ILLL,
    /* 0x15 */ ILLL,
    /* 0x16 */ 4,
    /* 0x17 */ ILLL,
    /* 0x18 */ ILLL,
    /* 0x19 */ ILLL,
    /* 0x1a */ ILLL,
    /* 0x1b */ ILLL,
    /* 0x1c */ ILLL,
    /* 0x1d */ ILLL,
    /* 0x1e */ 4,
    /* 0x1f */ ILLL,
    /* 0x20 */ ILLL,
    /* 0x21 */ ILLL,
    /* 0x22 */ ILLL,
    /* 0x23 */ ILLL,
    /* 0x24 */ ILLL,
    /* 0x25 */ ILLL,
    /* 0x26 */ 4,
    /* 0x27 */ ILLL,
    /* 0x28 */ ILLL,
    /* 0x29 */ ILLL,
    /* 0x2a */ ILLL,
    /* 0x2b */ ILLL,
    /* 0x2c */ ILLL,
    /* 0x2d */ ILLL,
    /* 0x2e */ 4,
    /* 0x2f */ ILLL,
    /* 0x30 */ ILLL,
    /* 0x31 */ ILLL,
    /* 0x32 */ ILLL,
    /* 0x33 */ ILLL,
    /* 0x34 */ ILLL,
    /* 0x35 */ ILLL,
    /* 0x36 */ ILLL,
    /* 0x37 */ ILLL,
    /* 0x38 */ ILLL,
    /* 0x39 */ ILLL,
    /* 0x3a */ ILLL,
    /* 0x3b */ ILLL,
    /* 0x3c */ ILLL,
    /* 0x3d */ ILLL,
    /* 0x3e */ 4,
    /* 0x3f */ ILLL,
    /* 0x40 */ ILLL,
    /* 0x41 */ ILLL,
    /* 0x42 */ ILLL,
    /* 0x43 */ ILLL,
    /* 0x44 */ ILLL,
    /* 0x45 */ ILLL,
    /* 0x46 */ 4,
    /* 0x47 */ ILLL,
    /* 0x48 */ ILLL,
    /* 0x49 */ ILLL,
    /* 0x4a */ ILLL,
    /* 0x4b */ ILLL,
    /* 0x4c */ ILLL,
    /* 0x4d */ ILLL,
    /* 0x4e */ 4,
    /* 0x4f */ ILLL,
    /* 0x50 */ ILLL,
    /* 0x51 */ ILLL,
    /* 0x52 */ ILLL,
    /* 0x53 */ ILLL,
    /* 0x54 */ ILLL,
    /* 0x55 */ ILLL,
    /* 0x56 */ 4,
    /* 0x57 */ ILLL,
    /* 0x58 */ ILLL,
    /* 0x59 */ ILLL,
    /* 0x5a */ ILLL,
    /* 0x5b */ ILLL,
    /* 0x5c */ ILLL,
    /* 0x5d */ ILLL,
    /* 0x5e */ 4,
    /* 0x5f */ ILLL,
    /* 0x60 */ ILLL,
    /* 0x61 */ ILLL,
    /* 0x62 */ ILLL,
    /* 0x63 */ ILLL,
    /* 0x64 */ ILLL,
    /* 0x65 */ ILLL,
    /* 0x66 */ 4,
    /* 0x67 */ ILLL,
    /* 0x68 */ ILLL,
    /* 0x69 */ ILLL,
    /* 0x6a */ ILLL,
    /* 0x6b */ ILLL,
    /* 0x6c */ ILLL,
    /* 0x6d */ ILLL,
    /* 0x6e */ 4,
    /* 0x6f */ ILLL,
    /* 0x70 */ ILLL,
    /* 0x71 */ ILLL,
    /* 0x72 */ ILLL,
    /* 0x73 */ ILLL,
    /* 0x74 */ ILLL,
    /* 0x75 */ ILLL,
    /* 0x76 */ 4,
    /* 0x77 */ ILLL,
    /* 0x78 */ ILLL,
    /* 0x79 */ ILLL,
    /* 0x7a */ ILLL,
    /* 0x7b */ ILLL,
    /* 0x7c */ ILLL,
    /* 0x7d */ ILLL,
    /* 0x7e */ 4,
    /* 0x7f */ ILLL,
    /* 0x80 */ ILLL,
    /* 0x81 */ ILLL,
    /* 0x82 */ ILLL,
    /* 0x83 */ ILLL,
    /* 0x84 */ ILLL,
    /* 0x85 */ ILLL,
    /* 0x86 */ 4,
    /* 0x87 */ ILLL,
    /* 0x88 */ ILLL,
    /* 0x89 */ ILLL,
    /* 0x8a */ ILLL,
    /* 0x8b */ ILLL,
    /* 0x8c */ ILLL,
    /* 0x8d */ ILLL,
    /* 0x8e */ 4,
    /* 0x8f */ ILLL,
    /* 0x90 */ ILLL,
    /* 0x91 */ ILLL,
    /* 0x92 */ ILLL,
    /* 0x93 */ ILLL,
    /* 0x94 */ ILLL,
    /* 0x95 */ ILLL,
    /* 0x96 */ 4,
    /* 0x97 */ ILLL,
    /* 0x98 */ ILLL,
    /* 0x99 */ ILLL,
    /* 0x9a */ ILLL,
    /* 0x9b */ ILLL,
    /* 0x9c */ ILLL,
    /* 0x9d */ ILLL,
    /* 0x9e */ 4,
    /* 0x9f */ ILLL,
    /* 0xa0 */ ILLL,
    /* 0xa1 */ ILLL,
    /* 0xa2 */ ILLL,
    /* 0xa3 */ ILLL,
    /* 0xa4 */ ILLL,
    /* 0xa5 */ ILLL,
    /* 0xa6 */ 4,
    /* 0xa7 */ ILLL,
    /* 0xa8 */ ILLL,
    /* 0xa9 */ ILLL,
    /* 0xaa */ ILLL,
    /* 0xab */ ILLL,
    /* 0xac */ ILLL,
    /* 0xad */ ILLL,
    /* 0xae */ 4,
    /* 0xaf */ ILLL,
    /* 0xb0 */ ILLL,
    /* 0xb1 */ ILLL,
    /* 0xb2 */ ILLL,
    /* 0xb3 */ ILLL,
    /* 0xb4 */ ILLL,
    /* 0xb5 */ ILLL,
    /* 0xb6 */ 4,
    /* 0xb7 */ ILLL,
    /* 0xb8 */ ILLL,
    /* 0xb9 */ ILLL,
    /* 0xba */ ILLL,
    /* 0xbb */ ILLL,
    /* 0xbc */ ILLL,
    /* 0xbd */ ILLL,
    /* 0xbe */ 4,
    /* 0xbf */ ILLL,
    /* 0xc0 */ ILLL,
    /* 0xc1 */ ILLL,
    /* 0xc2 */ ILLL,
    /* 0xc3 */ ILLL,
    /* 0xc4 */ ILLL,
    /* 0xc5 */ ILLL,
    /* 0xc6 */ 4,
    /* 0xc7 */ ILLL,
    /* 0xc8 */ ILLL,
    /* 0xc9 */ ILLL,
    /* 0xca */ ILLL,
    /* 0xcb */ ILLL,
    /* 0xcc */ ILLL,
    /* 0xcd */ ILLL,
    /* 0xce */ 4,
    /* 0xcf */ ILLL,
    /* 0xd0 */ ILLL,
    /* 0xd1 */ ILLL,
    /* 0xd2 */ ILLL,
    /* 0xd3 */ ILLL,
    /* 0xd4 */ ILLL,
    /* 0xd5 */ ILLL,
    /* 0xd6 */ 4,
    /* 0xd7 */ ILLL,
    /* 0xd8 */ ILLL,
    /* 0xd9 */ ILLL,
    /* 0xda */ ILLL,
    /* 0xdb */ ILLL,
    /* 0xdc */ ILLL,
    /* 0xdd */ ILLL,
    /* 0xde */ 4,
    /* 0xdf */ ILLL,
    /* 0xe0 */ ILLL,
    /* 0xe1 */ ILLL,
    /* 0xe2 */ ILLL,
    /* 0xe3 */ ILLL,
    /* 0xe4 */ ILLL,
    /* 0xe5 */ ILLL,
    /* 0xe6 */ 4,
    /* 0xe7 */ ILLL,
    /* 0xe8 */ ILLL,
    /* 0xe9 */ ILLL,
    /* 0xea */ ILLL,
    /* 0xeb */ ILLL,
    /* 0xec */ ILLL,
    /* 0xed */ ILLL,
    /* 0xee */ 4,
    /* 0xef */ ILLL,
    /* 0xf0 */ ILLL,
    /* 0xf1 */ ILLL,
    /* 0xf2 */ ILLL,
    /* 0xf3 */ ILLL,
    /* 0xf4 */ ILLL,
    /* 0xf5 */ ILLL,
    /* 0xf6 */ 4,
    /* 0xf7 */ ILLL,
    /* 0xf8 */ ILLL,
    /* 0xf9 */ ILLL,
    /* 0xfa */ ILLL,
    /* 0xfb */ ILLL,
    /* 0xfc */ ILLL,
    /* 0xfd */ ILLL,
    /* 0xfe */ 4,
    /* 0xff */ ILLL
  };

int Z80_LengthDDCB[256] =
  {
    /* 0x00 */ ILLL,
    /* 0x01 */ ILLL,
    /* 0x02 */ ILLL,
    /* 0x03 */ ILLL,
    /* 0x04 */ ILLL,
    /* 0x05 */ ILLL,
    /* 0x06 */ 4,
    /* 0x07 */ ILLL,
    /* 0x08 */ ILLL,
    /* 0x09 */ ILLL,
    /* 0x0a */ ILLL,
    /* 0x0b */ ILLL,
    /* 0x0c */ ILLL,
    /* 0x0d */ ILLL,
    /* 0x0e */ 4,
    /* 0x0f */ ILLL,
    /* 0x10 */ ILLL,
    /* 0x11 */ ILLL,
    /* 0x12 */ ILLL,
    /* 0x13 */ ILLL,
    /* 0x14 */ ILLL,
    /* 0x15 */ ILLL,
    /* 0x16 */ 4,
    /* 0x17 */ ILLL,
    /* 0x18 */ ILLL,
    /* 0x19 */ ILLL,
    /* 0x1a */ ILLL,
    /* 0x1b */ ILLL,
    /* 0x1c */ ILLL,
    /* 0x1d */ ILLL,
    /* 0x1e */ 4,
    /* 0x1f */ ILLL,
    /* 0x20 */ ILLL,
    /* 0x21 */ ILLL,
    /* 0x22 */ ILLL,
    /* 0x23 */ ILLL,
    /* 0x24 */ ILLL,
    /* 0x25 */ ILLL,
    /* 0x26 */ 4,
    /* 0x27 */ ILLL,
    /* 0x28 */ ILLL,
    /* 0x29 */ ILLL,
    /* 0x2a */ ILLL,
    /* 0x2b */ ILLL,
    /* 0x2c */ ILLL,
    /* 0x2d */ ILLL,
    /* 0x2e */ 4,
    /* 0x2f */ ILLL,
    /* 0x30 */ ILLL,
    /* 0x31 */ ILLL,
    /* 0x32 */ ILLL,
    /* 0x33 */ ILLL,
    /* 0x34 */ ILLL,
    /* 0x35 */ ILLL,
    /* 0x36 */ ILLL,
    /* 0x37 */ ILLL,
    /* 0x38 */ ILLL,
    /* 0x39 */ ILLL,
    /* 0x3a */ ILLL,
    /* 0x3b */ ILLL,
    /* 0x3c */ ILLL,
    /* 0x3d */ ILLL,
    /* 0x3e */ 4,
    /* 0x3f */ ILLL,
    /* 0x40 */ ILLL,
    /* 0x41 */ ILLL,
    /* 0x42 */ ILLL,
    /* 0x43 */ ILLL,
    /* 0x44 */ ILLL,
    /* 0x45 */ ILLL,
    /* 0x46 */ 4,
    /* 0x47 */ ILLL,
    /* 0x48 */ ILLL,
    /* 0x49 */ ILLL,
    /* 0x4a */ ILLL,
    /* 0x4b */ ILLL,
    /* 0x4c */ ILLL,
    /* 0x4d */ ILLL,
    /* 0x4e */ 4,
    /* 0x4f */ ILLL,
    /* 0x50 */ ILLL,
    /* 0x51 */ ILLL,
    /* 0x52 */ ILLL,
    /* 0x53 */ ILLL,
    /* 0x54 */ ILLL,
    /* 0x55 */ ILLL,
    /* 0x56 */ 4,
    /* 0x57 */ ILLL,
    /* 0x58 */ ILLL,
    /* 0x59 */ ILLL,
    /* 0x5a */ ILLL,
    /* 0x5b */ ILLL,
    /* 0x5c */ ILLL,
    /* 0x5d */ ILLL,
    /* 0x5e */ 4,
    /* 0x5f */ ILLL,
    /* 0x60 */ ILLL,
    /* 0x61 */ ILLL,
    /* 0x62 */ ILLL,
    /* 0x63 */ ILLL,
    /* 0x64 */ ILLL,
    /* 0x65 */ ILLL,
    /* 0x66 */ 4,
    /* 0x67 */ ILLL,
    /* 0x68 */ ILLL,
    /* 0x69 */ ILLL,
    /* 0x6a */ ILLL,
    /* 0x6b */ ILLL,
    /* 0x6c */ ILLL,
    /* 0x6d */ ILLL,
    /* 0x6e */ 4,
    /* 0x6f */ ILLL,
    /* 0x70 */ ILLL,
    /* 0x71 */ ILLL,
    /* 0x72 */ ILLL,
    /* 0x73 */ ILLL,
    /* 0x74 */ ILLL,
    /* 0x75 */ ILLL,
    /* 0x76 */ 4,
    /* 0x77 */ ILLL,
    /* 0x78 */ ILLL,
    /* 0x79 */ ILLL,
    /* 0x7a */ ILLL,
    /* 0x7b */ ILLL,
    /* 0x7c */ ILLL,
    /* 0x7d */ ILLL,
    /* 0x7e */ 4,
    /* 0x7f */ ILLL,
    /* 0x80 */ ILLL,
    /* 0x81 */ ILLL,
    /* 0x82 */ ILLL,
    /* 0x83 */ ILLL,
    /* 0x84 */ ILLL,
    /* 0x85 */ ILLL,
    /* 0x86 */ 4,
    /* 0x87 */ ILLL,
    /* 0x88 */ ILLL,
    /* 0x89 */ ILLL,
    /* 0x8a */ ILLL,
    /* 0x8b */ ILLL,
    /* 0x8c */ ILLL,
    /* 0x8d */ ILLL,
    /* 0x8e */ 4,
    /* 0x8f */ ILLL,
    /* 0x90 */ ILLL,
    /* 0x91 */ ILLL,
    /* 0x92 */ ILLL,
    /* 0x93 */ ILLL,
    /* 0x94 */ ILLL,
    /* 0x95 */ ILLL,
    /* 0x96 */ 4,
    /* 0x97 */ ILLL,
    /* 0x98 */ ILLL,
    /* 0x99 */ ILLL,
    /* 0x9a */ ILLL,
    /* 0x9b */ ILLL,
    /* 0x9c */ ILLL,
    /* 0x9d */ ILLL,
    /* 0x9e */ 4,
    /* 0x9f */ ILLL,
    /* 0xa0 */ ILLL,
    /* 0xa1 */ ILLL,
    /* 0xa2 */ ILLL,
    /* 0xa3 */ ILLL,
    /* 0xa4 */ ILLL,
    /* 0xa5 */ ILLL,
    /* 0xa6 */ 4,
    /* 0xa7 */ ILLL,
    /* 0xa8 */ ILLL,
    /* 0xa9 */ ILLL,
    /* 0xaa */ ILLL,
    /* 0xab */ ILLL,
    /* 0xac */ ILLL,
    /* 0xad */ ILLL,
    /* 0xae */ 4,
    /* 0xaf */ ILLL,
    /* 0xb0 */ ILLL,
    /* 0xb1 */ ILLL,
    /* 0xb2 */ ILLL,
    /* 0xb3 */ ILLL,
    /* 0xb4 */ ILLL,
    /* 0xb5 */ ILLL,
    /* 0xb6 */ 4,
    /* 0xb7 */ ILLL,
    /* 0xb8 */ ILLL,
    /* 0xb9 */ ILLL,
    /* 0xba */ ILLL,
    /* 0xbb */ ILLL,
    /* 0xbc */ ILLL,
    /* 0xbd */ ILLL,
    /* 0xbe */ 4,
    /* 0xbf */ ILLL,
    /* 0xc0 */ ILLL,
    /* 0xc1 */ ILLL,
    /* 0xc2 */ ILLL,
    /* 0xc3 */ ILLL,
    /* 0xc4 */ ILLL,
    /* 0xc5 */ ILLL,
    /* 0xc6 */ 4,
    /* 0xc7 */ ILLL,
    /* 0xc8 */ ILLL,
    /* 0xc9 */ ILLL,
    /* 0xca */ ILLL,
    /* 0xcb */ ILLL,
    /* 0xcc */ ILLL,
    /* 0xcd */ ILLL,
    /* 0xce */ 4,
    /* 0xcf */ ILLL,
    /* 0xd0 */ ILLL,
    /* 0xd1 */ ILLL,
    /* 0xd2 */ ILLL,
    /* 0xd3 */ ILLL,
    /* 0xd4 */ ILLL,
    /* 0xd5 */ ILLL,
    /* 0xd6 */ 4,
    /* 0xd7 */ ILLL,
    /* 0xd8 */ ILLL,
    /* 0xd9 */ ILLL,
    /* 0xda */ ILLL,
    /* 0xdb */ ILLL,
    /* 0xdc */ ILLL,
    /* 0xdd */ ILLL,
    /* 0xde */ 4,
    /* 0xdf */ ILLL,
    /* 0xe0 */ ILLL,
    /* 0xe1 */ ILLL,
    /* 0xe2 */ ILLL,
    /* 0xe3 */ ILLL,
    /* 0xe4 */ ILLL,
    /* 0xe5 */ ILLL,
    /* 0xe6 */ 4,
    /* 0xe7 */ ILLL,
    /* 0xe8 */ ILLL,
    /* 0xe9 */ ILLL,
    /* 0xea */ ILLL,
    /* 0xeb */ ILLL,
    /* 0xec */ ILLL,
    /* 0xed */ ILLL,
    /* 0xee */ 4,
    /* 0xef */ ILLL,
    /* 0xf0 */ ILLL,
    /* 0xf1 */ ILLL,
    /* 0xf2 */ ILLL,
    /* 0xf3 */ ILLL,
    /* 0xf4 */ ILLL,
    /* 0xf5 */ ILLL,
    /* 0xf6 */ 4,
    /* 0xf7 */ ILLL,
    /* 0xf8 */ ILLL,
    /* 0xf9 */ ILLL,
    /* 0xfa */ ILLL,
    /* 0xfb */ ILLL,
    /* 0xfc */ ILLL,
    /* 0xfd */ ILLL,
    /* 0xfe */ 4,
    /* 0xff */ ILLL
  };

char * Z80_Disasm[256] =
  {
    /* 0x00 */ "NOP",
    /* 0x01 */ "LD BC,%2%1h",
    /* 0x02 */ "LD (BC),A",
    /* 0x03 */ "INC BC",
    /* 0x04 */ "INC B",
    /* 0x05 */ "DEC B",
    /* 0x06 */ "LD B,%1h",
    /* 0x07 */ "RLCA",
    /* 0x08 */ "EX AF,AF'",
    /* 0x09 */ "ADD HL,BC",
    /* 0x0a */ "LD A,(BC)",
    /* 0x0b */ "DEC BC",
    /* 0x0c */ "INC C",
    /* 0x0d */ "DEC C",
    /* 0x0e */ "LD C,%1h",
    /* 0x0f */ "RRCA",
    /* 0x10 */ "DJNZ $1h",
    /* 0x11 */ "LD DE,%2%1h",
    /* 0x12 */ "LD (DE),A",
    /* 0x13 */ "INC DE",
    /* 0x14 */ "INC D",
    /* 0x15 */ "DEC D",
    /* 0x16 */ "LD D,%1h",
    /* 0x17 */ "RLA",
    /* 0x18 */ "JR $1h",
    /* 0x19 */ "ADD HL,DE",
    /* 0x1a */ "LD A,(DE)",
    /* 0x1b */ "DEC DE",
    /* 0x1c */ "INC E",
    /* 0x1d */ "DEC E",
    /* 0x1e */ "LD E,%1h",
    /* 0x1f */ "RRA",
    /* 0x20 */ "JR NZ,$1h",
    /* 0x21 */ "LD HL,%2%1h",
    /* 0x22 */ "LD (%2%1h),HL",
    /* 0x23 */ "INC HL",
    /* 0x24 */ "INC H",
    /* 0x25 */ "DEC H",
    /* 0x26 */ "LD H,%1h",
    /* 0x27 */ "DAA",
    /* 0x28 */ "JR Z,$1h",
    /* 0x29 */ "ADD HL,HL",
    /* 0x2a */ "LD HL,(%2%1h)",
    /* 0x2b */ "DEC HL",
    /* 0x2c */ "INC L",
    /* 0x2d */ "DEC L",
    /* 0x2e */ "LD L,%1h",
    /* 0x2f */ "CPL",
    /* 0x30 */ "JR NC,$1h",
    /* 0x31 */ "LD SP,%2%1h",
    /* 0x32 */ "LD (%2%1h),A",
    /* 0x33 */ "INC SP",
    /* 0x34 */ "INC (HL)",
    /* 0x35 */ "DEC (HL)",
    /* 0x36 */ "LD (HL),%1h",
    /* 0x37 */ "SCF",
    /* 0x38 */ "JR C,$1h",
    /* 0x39 */ "ADD HL,SP",
    /* 0x3a */ "LD A,(%2%1h)",
    /* 0x3b */ "DEC SP",
    /* 0x3c */ "INC A",
    /* 0x3d */ "DEC A",
    /* 0x3e */ "LD A,%1h",
    /* 0x3f */ "CCF",
    /* 0x40 */ "LD B,B",
    /* 0x41 */ "LD B,C",
    /* 0x42 */ "LD B,D",
    /* 0x43 */ "LD B,E",
    /* 0x44 */ "LD B,H",
    /* 0x45 */ "LD B,L",
    /* 0x46 */ "LD B,(HL)",
    /* 0x47 */ "LD B,A",
    /* 0x48 */ "LD C,B",
    /* 0x49 */ "LD C,C",
    /* 0x4a */ "LD C,D",
    /* 0x4b */ "LD C,E",
    /* 0x4c */ "LD C,H",
    /* 0x4d */ "LD C,L",
    /* 0x4e */ "LD C,(HL)",
    /* 0x4f */ "LD C,A",
    /* 0x50 */ "LD D,B",
    /* 0x51 */ "LD D,C",
    /* 0x52 */ "LD D,D",
    /* 0x53 */ "LD D,E",
    /* 0x54 */ "LD D,H",
    /* 0x55 */ "LD D,L",
    /* 0x56 */ "LD D,(HL)",
    /* 0x57 */ "LD D,A",
    /* 0x58 */ "LD E,B",
    /* 0x59 */ "LD E,C",
    /* 0x5a */ "LD E,D",
    /* 0x5b */ "LD E,E",
    /* 0x5c */ "LD E,H",
    /* 0x5d */ "LD E,L",
    /* 0x5e */ "LD E,(HL)",
    /* 0x5f */ "LD E,A",
    /* 0x60 */ "LD H,B",
    /* 0x61 */ "LD H,C",
    /* 0x62 */ "LD H,D",
    /* 0x63 */ "LD H,E",
    /* 0x64 */ "LD H,H",
    /* 0x65 */ "LD H,L",
    /* 0x66 */ "LD H,(HL)",
    /* 0x67 */ "LD H,A",
    /* 0x68 */ "LD L,B",
    /* 0x69 */ "LD L,C",
    /* 0x6a */ "LD L,D",
    /* 0x6b */ "LD L,E",
    /* 0x6c */ "LD L,H",
    /* 0x6d */ "LD L,L",
    /* 0x6e */ "LD L,(HL)",
    /* 0x6f */ "LD L,A",
    /* 0x70 */ "LD (HL),B",
    /* 0x71 */ "LD (HL),C",
    /* 0x72 */ "LD (HL),D",
    /* 0x73 */ "LD (HL),E",
    /* 0x74 */ "LD (HL),H",
    /* 0x75 */ "LD (HL),L",
    /* 0x76 */ "HALT",
    /* 0x77 */ "LD (HL),A",
    /* 0x78 */ "LD A,B",
    /* 0x79 */ "LD A,C",
    /* 0x7a */ "LD A,D",
    /* 0x7b */ "LD A,E",
    /* 0x7c */ "LD A,H",
    /* 0x7d */ "LD A,L",
    /* 0x7e */ "LD A,(HL)",
    /* 0x7f */ "LD A,A",
    /* 0x80 */ "ADD B",
    /* 0x81 */ "ADD C",
    /* 0x82 */ "ADD D",
    /* 0x83 */ "ADD E",
    /* 0x84 */ "ADD H",
    /* 0x85 */ "ADD L",
    /* 0x86 */ "ADD (HL)",
    /* 0x87 */ "ADD A",
    /* 0x88 */ "ADC B",
    /* 0x89 */ "ADC C",
    /* 0x8a */ "ADC D",
    /* 0x8b */ "ADC E",
    /* 0x8c */ "ADC H",
    /* 0x8d */ "ADC L",
    /* 0x8e */ "ADC (HL)",
    /* 0x8f */ "ADC A",
    /* 0x90 */ "SUB B",
    /* 0x91 */ "SUB C",
    /* 0x92 */ "SUB D",
    /* 0x93 */ "SUB E",
    /* 0x94 */ "SUB H",
    /* 0x95 */ "SUB L",
    /* 0x96 */ "SUB (HL)",
    /* 0x97 */ "SUB A",
    /* 0x98 */ "SBC B",
    /* 0x99 */ "SBC C",
    /* 0x9a */ "SBC D",
    /* 0x9b */ "SBC E",
    /* 0x9c */ "SBC H",
    /* 0x9d */ "SBC L",
    /* 0x9e */ "SBC (HL)",
    /* 0x9f */ "SBC A",
    /* 0xa0 */ "AND B",
    /* 0xa1 */ "AND C",
    /* 0xa2 */ "AND D",
    /* 0xa3 */ "AND E",
    /* 0xa4 */ "AND H",
    /* 0xa5 */ "AND L",
    /* 0xa6 */ "AND (HL)",
    /* 0xa7 */ "AND A",
    /* 0xa8 */ "XOR B",
    /* 0xa9 */ "XOR C",
    /* 0xaa */ "XOR D",
    /* 0xab */ "XOR E",
    /* 0xac */ "XOR H",
    /* 0xad */ "XOR L",
    /* 0xae */ "XOR (HL)",
    /* 0xaf */ "XOR A",
    /* 0xb0 */ "OR B",
    /* 0xb1 */ "OR C",
    /* 0xb2 */ "OR D",
    /* 0xb3 */ "OR E",
    /* 0xb4 */ "OR H",
    /* 0xb5 */ "OR L",
    /* 0xb6 */ "OR (HL)",
    /* 0xb7 */ "OR A",
    /* 0xb8 */ "CP B",
    /* 0xb9 */ "CP C",
    /* 0xba */ "CP D",
    /* 0xbb */ "CP E",
    /* 0xbc */ "CP H",
    /* 0xbd */ "CP L",
    /* 0xbe */ "CP (HL)",
    /* 0xbf */ "CP A",
    /* 0xc0 */ "RET NZ",
    /* 0xc1 */ "POP BC",
    /* 0xc2 */ "JP NZ,%2%1h",
    /* 0xc3 */ "JP %2%1h",
    /* 0xc4 */ "CALL NZ,%2%1h",
    /* 0xc5 */ "PUSH BC",
    /* 0xc6 */ "ADD %1h",
    /* 0xc7 */ "RST 00h",
    /* 0xc8 */ "RET Z",
    /* 0xc9 */ "RET",
    /* 0xca */ "JP Z,%2%1h",
    /* 0xcb */ ILLINST,
    /* 0xcc */ "CALL Z,%2%1h",
    /* 0xcd */ "CALL %2%1h",
    /* 0xce */ "ADC %1h",
    /* 0xcf */ "RST 08h",
    /* 0xd0 */ "RET NC",
    /* 0xd1 */ "POP DE",
    /* 0xd2 */ "JP NC,%2%1h",
    /* 0xd3 */ "OUTA (%1h)",
    /* 0xd4 */ "CALL NC,%2%1h",
    /* 0xd5 */ "PUSH DE",
    /* 0xd6 */ "SUB %1h",
    /* 0xd7 */ "RST 10h",
    /* 0xd8 */ "RET C",
    /* 0xd9 */ "EXX",
    /* 0xda */ "JP C,%2%1h",
    /* 0xdb */ "INA (%1h)",
    /* 0xdc */ "CALL C,%2%1h",
    /* 0xdd */ ILLINST,
    /* 0xde */ "SBC %1h",
    /* 0xdf */ "RST 18h",
    /* 0xe0 */ "RET PO",
    /* 0xe1 */ "POP HL",
    /* 0xe2 */ "JP PO,%2%1h",
    /* 0xe3 */ "EX HL,(SP)",
    /* 0xe4 */ "CALL PO,%2%1h",
    /* 0xe5 */ "PUSH HL",
    /* 0xe6 */ "AND %1h",
    /* 0xe7 */ "RST 20h",
    /* 0xe8 */ "RET PE",
    /* 0xe9 */ "LD PC,HL",
    /* 0xea */ "JP PE,%2%1h",
    /* 0xeb */ "EX DE,HL",
    /* 0xec */ "CALL PE,%2%1h",
    /* 0xed */ ILLINST,
    /* 0xee */ "XOR %1h",
    /* 0xef */ "RST 28h",
    /* 0xf0 */ "RET P",
    /* 0xf1 */ "POP AF",
    /* 0xf2 */ "JP P,%2%1h",
    /* 0xf3 */ "DI",
    /* 0xf4 */ "CALL P,%2%1h",
    /* 0xf5 */ "PUSH AF",
    /* 0xf6 */ "OR %1h",
    /* 0xf7 */ "RST 30h",
    /* 0xf8 */ "RET M",
    /* 0xf9 */ "LD SP,HL",
    /* 0xfa */ "JP M,%2%1h",
    /* 0xfb */ "EI",
    /* 0xfc */ "CALL M,%2%1h",
    /* 0xfd */ ILLINST,
    /* 0xfe */ "CP %1h",
    /* 0xff */ "RST 38h"
  };

char * Z80_DisasmCB[256] =
  {
    /* 0x00 */ "RLC B",
    /* 0x01 */ "RLC C",
    /* 0x02 */ "RLC D",
    /* 0x03 */ "RLC E",
    /* 0x04 */ "RLC H",
    /* 0x05 */ "RLC L",
    /* 0x06 */ "RLC (HL)",
    /* 0x07 */ "RLC A",
    /* 0x08 */ "RRC B",
    /* 0x09 */ "RRC C",
    /* 0x0a */ "RRC D",
    /* 0x0b */ "RRC E",
    /* 0x0c */ "RRC H",
    /* 0x0d */ "RRC L",
    /* 0x0e */ "RRC (HL)",
    /* 0x0f */ "RRC A",
    /* 0x10 */ "RL B",
    /* 0x11 */ "RL C",
    /* 0x12 */ "RL D",
    /* 0x13 */ "RL E",
    /* 0x14 */ "RL H",
    /* 0x15 */ "RL L",
    /* 0x16 */ "RL (HL)",
    /* 0x17 */ "RL A",
    /* 0x18 */ "RR B",
    /* 0x19 */" RR C",
    /* 0x1a */ "RR D",
    /* 0x1b */ "RR E",
    /* 0x1c */ "RR H",
    /* 0x1d */ "RR L",
    /* 0x1e */ "RR (HL)",
    /* 0x1f */ "RR A",
    /* 0x20 */ "SLA B",
    /* 0x21 */ "SLA C",
    /* 0x22 */ "SLA D",
    /* 0x23 */ "SLA E",
    /* 0x24 */ "SLA H",
    /* 0x25 */ "SLA L",
    /* 0x26 */ "SLA (HL)",
    /* 0x27 */ "SLA A",
    /* 0x28 */ "SRA B",
    /* 0x29 */ "SRA C",
    /* 0x2a */ "SRA D",
    /* 0x2b */ "SRA E",
    /* 0x2c */ "SRA H",
    /* 0x2d */ "SRA L",
    /* 0x2e */ "SRA (HL)",
    /* 0x2f */ "SRA A",
    /* 0x30 */ ILLINST,
    /* 0x31 */ ILLINST,
    /* 0x32 */ ILLINST,
    /* 0x33 */ ILLINST,
    /* 0x34 */ ILLINST,
    /* 0x35 */ ILLINST,
    /* 0x36 */ ILLINST,
    /* 0x37 */ ILLINST,
    /* 0x38 */ "SRL B",
    /* 0x39 */ "SRL C",
    /* 0x3a */ "SRL D",
    /* 0x3b */ "SRL E",
    /* 0x3c */ "SRL H",
    /* 0x3d */ "SRL L",
    /* 0x3e */ "SRL (HL)",
    /* 0x3f */ "SRL A",
    /* 0x40 */ "BIT 0,B",
    /* 0x41 */ "BIT 0,C",
    /* 0x42 */ "BIT 0,D",
    /* 0x43 */ "BIT 0,E",
    /* 0x44 */ "BIT 0,H",
    /* 0x45 */ "BIT 0,L",
    /* 0x46 */ "BIT 0,(HL)",
    /* 0x47 */ "BIT 0,A",
    /* 0x48 */ "BIT 1,B",
    /* 0x49 */ "BIT 1,C",
    /* 0x4a */ "BIT 1,D",
    /* 0x4b */ "BIT 1,E",
    /* 0x4c */ "BIT 1,H",
    /* 0x4d */ "BIT 1,L",
    /* 0x4e */ "BIT 1,(HL)",
    /* 0x4f */ "BIT 1,A",
    /* 0x50 */ "BIT 2,B",
    /* 0x51 */ "BIT 2,C",
    /* 0x52 */ "BIT 2,D",
    /* 0x53 */ "BIT 2,E",
    /* 0x54 */ "BIT 2,H",
    /* 0x55 */ "BIT 2,L",
    /* 0x56 */ "BIT 2,(HL)",
    /* 0x57 */ "BIT 2,A",
    /* 0x58 */ "BIT 3,B",
    /* 0x59 */ "BIT 3,C",
    /* 0x5a */ "BIT 3,D",
    /* 0x5b */ "BIT 3,E",
    /* 0x5c */ "BIT 3,H",
    /* 0x5d */ "BIT 3,L",
    /* 0x5e */ "BIT 3,(HL)",
    /* 0x5f */ "BIT 3,A",
    /* 0x60 */ "BIT 4,B",
    /* 0x61 */ "BIT 4,C",
    /* 0x62 */ "BIT 4,D",
    /* 0x63 */ "BIT 4,E",
    /* 0x64 */ "BIT 4,H",
    /* 0x65 */ "BIT 4,L",
    /* 0x66 */ "BIT 4,(HL)",
    /* 0x67 */ "BIT 4,A",
    /* 0x68 */ "BIT 5,B",
    /* 0x69 */ "BIT 5,C",
    /* 0x6a */ "BIT 5,D",
    /* 0x6b */ "BIT 5,E",
    /* 0x6c */ "BIT 5,H",
    /* 0x6d */ "BIT 5,L",
    /* 0x6e */ "BIT 5,(HL)",
    /* 0x6f */ "BIT 5,A",
    /* 0x70 */ "BIT 6,B",
    /* 0x71 */ "BIT 6,C",
    /* 0x72 */ "BIT 6,D",
    /* 0x73 */ "BIT 6,E",
    /* 0x74 */ "BIT 6,H",
    /* 0x75 */ "BIT 6,L",
    /* 0x76 */ "BIT 6,(HL)",
    /* 0x77 */ "BIT 6,A",
    /* 0x78 */ "BIT 7,B",
    /* 0x79 */ "BIT 7,C",
    /* 0x7a */ "BIT 7,D",
    /* 0x7b */ "BIT 7,E",
    /* 0x7c */ "BIT 7,H",
    /* 0x7d */ "BIT 7,L",
    /* 0x7e */ "BIT 7,(HL)",
    /* 0x7f */ "BIT 7,A",
    /* 0x80 */ "RES 0,B",
    /* 0x81 */ "RES 0,C",
    /* 0x82 */ "RES 0,D",
    /* 0x83 */ "RES 0,E",
    /* 0x84 */ "RES 0,H",
    /* 0x85 */ "RES 0,L",
    /* 0x86 */ "RES 0,(HL)",
    /* 0x87 */ "RES 0,A",
    /* 0x88 */ "RES 1,B",
    /* 0x89 */ "RES 1,C",
    /* 0x8a */ "RES 1,D",
    /* 0x8b */ "RES 1,E",
    /* 0x8c */ "RES 1,H",
    /* 0x8d */ "RES 1,L",
    /* 0x8e */ "RES 1,(HL)",
    /* 0x8f */ "RES 1,A",
    /* 0x90 */ "RES 2,B",
    /* 0x91 */ "RES 2,C",
    /* 0x92 */ "RES 2,D",
    /* 0x93 */ "RES 2,E",
    /* 0x94 */ "RES 2,H",
    /* 0x95 */ "RES 2,L",
    /* 0x96 */ "RES 2,(HL)",
    /* 0x97 */ "RES 2,A",
    /* 0x98 */ "RES 3,B",
    /* 0x99 */ "RES 3,C",
    /* 0x9a */ "RES 3,D",
    /* 0x9b */ "RES 3,E",
    /* 0x9c */ "RES 3,H",
    /* 0x9d */ "RES 3,L",
    /* 0x9e */ "RES 3,(HL)",
    /* 0x9f */ "RES 3,A",
    /* 0xa0 */ "RES 4,B",
    /* 0xa1 */ "RES 4,C",
    /* 0xa2 */ "RES 4,D",
    /* 0xa3 */ "RES 4,E",
    /* 0xa4 */ "RES 4,H",
    /* 0xa5 */ "RES 4,L",
    /* 0xa6 */ "RES 4,(HL)",
    /* 0xa7 */ "RES 4,A",
    /* 0xa8 */ "RES 5,B",
    /* 0xa9 */ "RES 5,C",
    /* 0xaa */ "RES 5,D",
    /* 0xab */ "RES 5,E",
    /* 0xac */ "RES 5,H",
    /* 0xad */ "RES 5,L",
    /* 0xae */ "RES 5,(HL)",
    /* 0xaf */ "RES 5,A",
    /* 0xb0 */ "RES 6,B",
    /* 0xb1 */ "RES 6,C",
    /* 0xb2 */ "RES 6,D",
    /* 0xb3 */ "RES 6,E",
    /* 0xb4 */ "RES 6,H",
    /* 0xb5 */ "RES 6,L",
    /* 0xb6 */ "RES 6,(HL)",
    /* 0xb7 */ "RES 6,A",
    /* 0xb8 */ "RES 7,B",
    /* 0xb9 */ "RES 7,C",
    /* 0xba */ "RES 7,D",
    /* 0xbb */ "RES 7,E",
    /* 0xbc */ "RES 7,H",
    /* 0xbd */ "RES 7,L",
    /* 0xbe */ "RES 7,(HL)",
    /* 0xbf */ "RES 7,A",
    /* 0xc0 */ "SET 0,B",
    /* 0xc1 */ "SET 0,C",
    /* 0xc2 */ "SET 0,D",
    /* 0xc3 */ "SET 0,E",
    /* 0xc4 */ "SET 0,H",
    /* 0xc5 */ "SET 0,L",
    /* 0xc6 */ "SET 0,(HL)",
    /* 0xc7 */ "SET 0,A",
    /* 0xc8 */ "SET 1,B",
    /* 0xc9 */ "SET 1,C",
    /* 0xca */ "SET 1,D",
    /* 0xcb */ "SET 1,E",
    /* 0xcc */ "SET 1,H",
    /* 0xcd */ "SET 1,L",
    /* 0xce */ "SET 1,(HL)",
    /* 0xcf */ "SET 1,A",
    /* 0xd0 */ "SET 2,B",
    /* 0xd1 */ "SET 2,C",
    /* 0xd2 */ "SET 2,D",
    /* 0xd3 */ "SET 2,E",
    /* 0xd4 */ "SET 2,H",
    /* 0xd5 */ "SET 2,L",
    /* 0xd6 */ "SET 2,(HL)",
    /* 0xd7 */ "SET 2,A",
    /* 0xd8 */ "SET 3,B",
    /* 0xd9 */ "SET 3,C",
    /* 0xda */ "SET 3,D",
    /* 0xdb */ "SET 3,E",
    /* 0xdc */ "SET 3,H",
    /* 0xdd */ "SET 3,L",
    /* 0xde */ "SET 3,(HL)",
    /* 0xdf */ "SET 3,A",
    /* 0xe0 */ "SET 4,B",
    /* 0xe1 */ "SET 4,C",
    /* 0xe2 */ "SET 4,D",
    /* 0xe3 */ "SET 4,E",
    /* 0xe4 */ "SET 4,H",
    /* 0xe5 */ "SET 4,L",
    /* 0xe6 */ "SET 4,(HL)",
    /* 0xe7 */ "SET 4,A",
    /* 0xe8 */ "SET 5,B",
    /* 0xe9 */ "SET 5,C",
    /* 0xea */ "SET 5,D",
    /* 0xeb */ "SET 5,E",
    /* 0xec */ "SET 5,H",
    /* 0xed */ "SET 5,L",
    /* 0xee */ "SET 5,(HL)",
    /* 0xef */ "SET 5,A",
    /* 0xf0 */ "SET 6,B",
    /* 0xf1 */ "SET 6,C",
    /* 0xf2 */ "SET 6,D",
    /* 0xf3 */ "SET 6,E",
    /* 0xf4 */ "SET 6,H",
    /* 0xf5 */ "SET 6,L",
    /* 0xf6 */ "SET 6,(HL)",
    /* 0xf7 */ "SET 6,A",
    /* 0xf8 */ "SET 7,B",
    /* 0xf9 */ "SET 7,C",
    /* 0xfa */ "SET 7,D",
    /* 0xfb */ "SET 7,E",
    /* 0xfc */ "SET 7,H",
    /* 0xfd */ "SET 7,L",
    /* 0xfe */ "SET 7,(HL)",
    /* 0xff */ "SET 7,A"
  };

char * Z80_DisasmFD[256] =
  {
    /* 0x00 */ ILLINST,
    /* 0x01 */ ILLINST,
    /* 0x02 */ "LD (BC),A",
    /* 0x03 */ ILLINST,
    /* 0x04 */ ILLINST,
    /* 0x05 */ ILLINST,
    /* 0x06 */ ILLINST,
    /* 0x07 */ ILLINST,
    /* 0x08 */ ILLINST,
    /* 0x09 */ "ADD IY,BC",
    /* 0x0a */ "LD A,(BC)",
    /* 0x0b */ ILLINST,
    /* 0x0c */ ILLINST,
    /* 0x0d */ ILLINST,
    /* 0x0e */ ILLINST,
    /* 0x0f */ ILLINST,
    /* 0x10 */ ILLINST,
    /* 0x11 */ ILLINST,
    /* 0x12 */ ILLINST,
    /* 0x13 */ ILLINST,
    /* 0x14 */ ILLINST,
    /* 0x15 */ ILLINST,
    /* 0x16 */ ILLINST,
    /* 0x17 */ ILLINST,
    /* 0x18 */ ILLINST,
    /* 0x19 */ "ADD IY,DE",
    /* 0x1a */ ILLINST,
    /* 0x1b */ ILLINST,
    /* 0x1c */ ILLINST,
    /* 0x1d */ ILLINST,
    /* 0x1e */ ILLINST,
    /* 0x1f */ ILLINST,
    /* 0x20 */ ILLINST,
    /* 0x21 */ "LD IY,%3%2h",
    /* 0x22 */ "LD (%3%2h),IY",
    /* 0x23 */ "INC IY",
    /* 0x24 */ ILLINST,
    /* 0x25 */ ILLINST,
    /* 0x26 */ "LD IYh,%2h",
    /* 0x27 */ ILLINST,
    /* 0x28 */ ILLINST,
    /* 0x29 */ "ADD IY,IY",
    /* 0x2a */ "LD IY,(%3%2h)",
    /* 0x2b */ "DEC IY",
    /* 0x2c */ ILLINST,
    /* 0x2d */ "DEC IYl",
    /* 0x2e */ "LD IYl,%2h",
    /* 0x2f */ ILLINST,
    /* 0x30 */ ILLINST,
    /* 0x31 */ ILLINST,
    /* 0x32 */ ILLINST,
    /* 0x33 */ ILLINST,
    /* 0x34 */ "INC (IY+%2h)",
    /* 0x35 */ "DEC (IY+%2h)",
    /* 0x36 */ "LD (IY+%2h),%3h",
    /* 0x37 */ ILLINST,
    /* 0x38 */ ILLINST,
    /* 0x39 */ "ADD IY,SP",
    /* 0x3a */ ILLINST,
    /* 0x3b */ ILLINST,
    /* 0x3c */ ILLINST,
    /* 0x3d */ ILLINST,
    /* 0x3e */ ILLINST,
    /* 0x3f */ ILLINST,
    /* 0x40 */ ILLINST,
    /* 0x41 */ ILLINST,
    /* 0x42 */ ILLINST,
    /* 0x43 */ ILLINST,
    /* 0x44 */ ILLINST,
    /* 0x45 */ "LD B,IYl",
    /* 0x46 */ "LD B,(IY+%2h)",
    /* 0x47 */ ILLINST,
    /* 0x48 */ ILLINST,
    /* 0x49 */ ILLINST,
    /* 0x4a */ ILLINST,
    /* 0x4b */ ILLINST,
    /* 0x4c */ ILLINST,
    /* 0x4d */ "LD C,IYl",
    /* 0x4e */ "LD C,(IY+%2h)",
    /* 0x4f */ ILLINST,
    /* 0x50 */ ILLINST,
    /* 0x51 */ ILLINST,
    /* 0x52 */ ILLINST,
    /* 0x53 */ ILLINST,
    /* 0x54 */ "LD D,IYh",
    /* 0x55 */ "LD D,IYl",
    /* 0x56 */ "LD D,(IY+%2h)",
    /* 0x57 */ ILLINST,
    /* 0x58 */ ILLINST,
    /* 0x59 */ ILLINST,
    /* 0x5a */ ILLINST,
    /* 0x5b */ ILLINST,
    /* 0x5c */ ILLINST,
    /* 0x5d */ "LD E,IYl",
    /* 0x5e */ "LD E,(IY+%2h)",
    /* 0x5f */ ILLINST,
    /* 0x60 */ "LD IYh,B",
    /* 0x61 */ "LD IYh,C",
    /* 0x62 */ "LD IYh,D",
    /* 0x63 */ "LD IYh,E",
    /* 0x64 */ "LD IYh,H",
    /* 0x65 */ "LD IYh,L",
    /* 0x66 */ "LD H,(IY+%2h)",
    /* 0x67 */ "LD IYh,A",
    /* 0x68 */ "LD IYl,B",
    /* 0x69 */ "LD IYl,C",
    /* 0x6a */ "LD IYl,D",
    /* 0x6b */ "LD IYl,E",
    /* 0x6c */ "LD IYl,H",
    /* 0x6d */ "LD IYl,L",
    /* 0x6e */ "LD L,(IY+%2h)",
    /* 0x6f */ "LD IYl,A",
    /* 0x70 */ "LD (IY+%2h),B",
    /* 0x71 */ "LD (IY+%2h),C",
    /* 0x72 */ "LD (IY+%2h),D",
    /* 0x73 */ "LD (IY+%2h),E",
    /* 0x74 */ "LD (IY+%2h),H",
    /* 0x75 */ "LD (IY+%2h),L",
    /* 0x76 */ ILLINST,
    /* 0x77 */ "LD (IY+%2h),A",
    /* 0x78 */ ILLINST,
    /* 0x79 */ ILLINST,
    /* 0x7a */ ILLINST,
    /* 0x7b */ ILLINST,
    /* 0x7c */ "LD A,IYh",
    /* 0x7d */ "LD A,IYl",
    /* 0x7e */ "LD A,(IY+%2h)",
    /* 0x7f */ ILLINST,
    /* 0x80 */ ILLINST,
    /* 0x81 */ ILLINST,
    /* 0x82 */ ILLINST,
    /* 0x83 */ ILLINST,
    /* 0x84 */ ILLINST,
    /* 0x85 */ "ADD IYl",
    /* 0x86 */ "ADD (IY+%2h)",
    /* 0x87 */ ILLINST,
    /* 0x88 */ ILLINST,
    /* 0x89 */ ILLINST,
    /* 0x8a */ ILLINST,
    /* 0x8b */ ILLINST,
    /* 0x8c */ ILLINST,
    /* 0x8d */ "ADC IYl",
    /* 0x8e */ "ADC (IY+%2h)",
    /* 0x8f */ ILLINST,
    /* 0x90 */ ILLINST,
    /* 0x91 */ ILLINST,
    /* 0x92 */ ILLINST,
    /* 0x93 */ ILLINST,
    /* 0x94 */ ILLINST,
    /* 0x95 */ ILLINST,
    /* 0x96 */ "SUB (IY+%2h)",
    /* 0x97 */ ILLINST,
    /* 0x98 */ ILLINST,
    /* 0x99 */ ILLINST,
    /* 0x9a */ ILLINST,
    /* 0x9b */ ILLINST,
    /* 0x9c */ "SBC IYh",
    /* 0x9d */ ILLINST,
    /* 0x9e */ "SBC (IY+%2h)",
    /* 0x9f */ ILLINST,
    /* 0xa0 */ ILLINST,
    /* 0xa1 */ ILLINST,
    /* 0xa2 */ ILLINST,
    /* 0xa3 */ ILLINST,
    /* 0xa4 */ ILLINST,
    /* 0xa5 */ ILLINST,
    /* 0xa6 */ "AND (IY+%2h)",
    /* 0xa7 */ ILLINST,
    /* 0xa8 */ ILLINST,
    /* 0xa9 */ ILLINST,
    /* 0xaa */ ILLINST,
    /* 0xab */ ILLINST,
    /* 0xac */ ILLINST,
    /* 0xad */ "XOR IYl",
    /* 0xae */ "XOR (IY+%2h)",
    /* 0xaf */ ILLINST,
    /* 0xb0 */ ILLINST,
    /* 0xb1 */ ILLINST,
    /* 0xb2 */ ILLINST,
    /* 0xb3 */ ILLINST,
    /* 0xb4 */ ILLINST,
    /* 0xb5 */ "OR IYl",
    /* 0xb6 */ "OR (IY+%2h)",
    /* 0xb7 */ ILLINST,
    /* 0xb8 */ ILLINST,
    /* 0xb9 */ ILLINST,
    /* 0xba */ ILLINST,
    /* 0xbb */ ILLINST,
    /* 0xbc */ ILLINST,
    /* 0xbd */ "CP IYl",
    /* 0xbe */ "CP (IY+%2h)",
    /* 0xbf */ ILLINST,
    /* 0xc0 */ ILLINST,
    /* 0xc1 */ ILLINST,
    /* 0xc2 */ ILLINST,
    /* 0xc3 */ ILLINST,
    /* 0xc4 */ ILLINST,
    /* 0xc5 */ ILLINST,
    /* 0xc6 */ ILLINST,
    /* 0xc7 */ ILLINST,
    /* 0xc8 */ ILLINST,
    /* 0xc9 */ ILLINST,
    /* 0xca */ ILLINST,
    /* 0xcb */ ILLINST,
    /* 0xcc */ ILLINST,
    /* 0xcd */ ILLINST,
    /* 0xce */ ILLINST,
    /* 0xcf */ ILLINST,
    /* 0xd0 */ ILLINST,
    /* 0xd1 */ ILLINST,
    /* 0xd2 */ ILLINST,
    /* 0xd3 */ ILLINST,
    /* 0xd4 */ ILLINST,
    /* 0xd5 */ ILLINST,
    /* 0xd6 */ ILLINST,
    /* 0xd7 */ ILLINST,
    /* 0xd8 */ ILLINST,
    /* 0xd9 */ ILLINST,
    /* 0xda */ ILLINST,
    /* 0xdb */ ILLINST,
    /* 0xdc */ ILLINST,
    /* 0xdd */ ILLINST,
    /* 0xde */ ILLINST,
    /* 0xdf */ ILLINST,
    /* 0xe0 */ ILLINST,
    /* 0xe1 */ "POP IY",
    /* 0xe2 */ ILLINST,
    /* 0xe3 */ "EX IY,(SP)",
    /* 0xe4 */ ILLINST,
    /* 0xe5 */ "PUSH IY",
    /* 0xe6 */ ILLINST,
    /* 0xe7 */ ILLINST,
    /* 0xe8 */ ILLINST,
    /* 0xe9 */ "LD PC,IY",
    /* 0xea */ ILLINST,
    /* 0xeb */ "EX DE,IY",
    /* 0xec */ ILLINST,
    /* 0xed */ ILLINST,
    /* 0xee */ ILLINST,
    /* 0xef */ ILLINST,
    /* 0xf0 */ ILLINST,
    /* 0xf1 */ ILLINST,
    /* 0xf2 */ ILLINST,
    /* 0xf3 */ ILLINST,
    /* 0xf4 */ ILLINST,
    /* 0xf5 */ ILLINST,
    /* 0xf6 */ ILLINST,
    /* 0xf7 */ ILLINST,
    /* 0xf8 */ ILLINST,
    /* 0xf9 */ "LD SP,IY",
    /* 0xfa */ ILLINST,
    /* 0xfb */ ILLINST,
    /* 0xfc */ ILLINST,
    /* 0xfd */ ILLINST,
    /* 0xfe */ ILLINST,
    /* 0xff */ ILLINST
  };

char * Z80_DisasmDD[256] =
  {
    /* 0x00 */ ILLINST,
    /* 0x01 */ ILLINST,
    /* 0x02 */ ILLINST,
    /* 0x03 */ "INC BC",
    /* 0x04 */ ILLINST,
    /* 0x05 */ ILLINST,
    /* 0x06 */ ILLINST,
    /* 0x07 */ ILLINST,
    /* 0x08 */ ILLINST,
    /* 0x09 */ "ADD IX,BC",
    /* 0x0a */ ILLINST,
    /* 0x0b */ ILLINST,
    /* 0x0c */ ILLINST,
    /* 0x0d */ ILLINST,
    /* 0x0e */ ILLINST,
    /* 0x0f */ ILLINST,
    /* 0x10 */ ILLINST,
    /* 0x11 */ ILLINST,
    /* 0x12 */ ILLINST,
    /* 0x13 */ ILLINST,
    /* 0x14 */ ILLINST,
    /* 0x15 */ ILLINST,
    /* 0x16 */ ILLINST,
    /* 0x17 */ ILLINST,
    /* 0x18 */ ILLINST,
    /* 0x19 */ "ADD IX,DE",
    /* 0x1a */ ILLINST,
    /* 0x1b */ ILLINST,
    /* 0x1c */ ILLINST,
    /* 0x1d */ ILLINST,
    /* 0x1e */ ILLINST,
    /* 0x1f */ ILLINST,
    /* 0x20 */ ILLINST,
    /* 0x21 */ "LD IX,%3%2h",
    /* 0x22 */ "LD (%3%2h),IX",
    /* 0x23 */ "INC IX",
    /* 0x24 */ "INC IXh",
    /* 0x25 */ ILLINST,
    /* 0x26 */ "LD IXh,%2h",
    /* 0x27 */ ILLINST,
    /* 0x28 */ ILLINST,
    /* 0x29 */ "ADD IX,IX",
    /* 0x2a */ "LD IX,(%3%2h)",
    /* 0x2b */ "DEC IX",
    /* 0x2c */ ILLINST,
    /* 0x2d */ ILLINST,
    /* 0x2e */ ILLINST,
    /* 0x2f */ ILLINST,
    /* 0x30 */ ILLINST,
    /* 0x31 */ ILLINST,
    /* 0x32 */ ILLINST,
    /* 0x33 */ ILLINST,
    /* 0x34 */ "INC (IX+%2h)",
    /* 0x35 */ "DEC (IX+%2h)",
    /* 0x36 */ "LD (IX+%2h),%3h",
    /* 0x37 */ ILLINST,
    /* 0x38 */ ILLINST,
    /* 0x39 */ "ADD IX,SP",
    /* 0x3a */ ILLINST,
    /* 0x3b */ ILLINST,
    /* 0x3c */ ILLINST,
    /* 0x3d */ ILLINST,
    /* 0x3e */ ILLINST,
    /* 0x3f */ ILLINST,
    /* 0x40 */ ILLINST,
    /* 0x41 */ ILLINST,
    /* 0x42 */ ILLINST,
    /* 0x43 */ ILLINST,
    /* 0x44 */ ILLINST,
    /* 0x45 */ "LD B,IXl",
    /* 0x46 */ "LD B,(IX+%2h)",
    /* 0x47 */ ILLINST,
    /* 0x48 */ ILLINST,
    /* 0x49 */ ILLINST,
    /* 0x4a */ ILLINST,
    /* 0x4b */ ILLINST,
    /* 0x4c */ ILLINST,
    /* 0x4d */ "LD C,IXl",
    /* 0x4e */ "LD C,(IX+%2h)",
    /* 0x4f */ ILLINST,
    /* 0x50 */ ILLINST,
    /* 0x51 */ ILLINST,
    /* 0x52 */ ILLINST,
    /* 0x53 */ ILLINST,
    /* 0x54 */ "LD D,IXh",
    /* 0x55 */ "LD D,IXl",
    /* 0x56 */ "LD D,(IX+%2h)",
    /* 0x57 */ ILLINST,
    /* 0x58 */ ILLINST,
    /* 0x59 */ ILLINST,
    /* 0x5a */ ILLINST,
    /* 0x5b */ ILLINST,
    /* 0x5c */ ILLINST,
    /* 0x5d */ "LD E,IXl",
    /* 0x5e */ "LD E,(IX+%2h)",
    /* 0x5f */ ILLINST,
    /* 0x60 */ "LD IXh,B",
    /* 0x61 */ ILLINST,
    /* 0x62 */ "LD IXh,D",
    /* 0x63 */ ILLINST,
    /* 0x64 */ ILLINST,
    /* 0x65 */ ILLINST,
    /* 0x66 */ "LD H,(IX+%2h)",
    /* 0x67 */ "LD IXh,A",
    /* 0x68 */ "LD IXl,B",
    /* 0x69 */ ILLINST,
    /* 0x6a */ ILLINST,
    /* 0x6b */ "LD IXl,E",
    /* 0x6c */ ILLINST,
    /* 0x6d */ ILLINST,
    /* 0x6e */ "LD L,(IX+%2h)",
    /* 0x6f */ "LD IXl,A",
    /* 0x70 */ "LD (IX+%2h),B",
    /* 0x71 */ "LD (IX+%2h),C",
    /* 0x72 */ "LD (IX+%2h),D",
    /* 0x73 */ "LD (IX+%2h),E",
    /* 0x74 */ "LD (IX+%2h),H",
    /* 0x75 */ "LD (IX+%2h),L",
    /* 0x76 */ ILLINST,
    /* 0x77 */ "LD (IX+%2h),A",
    /* 0x78 */ ILLINST,
    /* 0x79 */ ILLINST,
    /* 0x7a */ ILLINST,
    /* 0x7b */ ILLINST,
    /* 0x7c */ "LD A,IXh",
    /* 0x7d */ "LD A,IXl",
    /* 0x7e */ "LD A,(IX+%2h)",
    /* 0x7f */ ILLINST,
    /* 0x80 */ ILLINST,
    /* 0x81 */ ILLINST,
    /* 0x82 */ ILLINST,
    /* 0x83 */ ILLINST,
    /* 0x84 */ ILLINST,
    /* 0x85 */ "ADD IXl",
    /* 0x86 */ "ADD (IX+%2h)",
    /* 0x87 */ ILLINST,
    /* 0x88 */ ILLINST,
    /* 0x89 */ ILLINST,
    /* 0x8a */ ILLINST,
    /* 0x8b */ ILLINST,
    /* 0x8c */ "ADC IXh",
    /* 0x8d */ "ADC IXl",
    /* 0x8e */ "ADC (IX+%2h)",
    /* 0x8f */ ILLINST,
    /* 0x90 */ ILLINST,
    /* 0x91 */ ILLINST,
    /* 0x92 */ ILLINST,
    /* 0x93 */ ILLINST,
    /* 0x94 */ ILLINST,
    /* 0x95 */ "SUB IXl",
    /* 0x96 */ "SUB (IX+%2h)",
    /* 0x97 */ ILLINST,
    /* 0x98 */ ILLINST,
    /* 0x99 */ ILLINST,
    /* 0x9a */ ILLINST,
    /* 0x9b */ ILLINST,
    /* 0x9c */ ILLINST,
    /* 0x9d */ ILLINST,
    /* 0x9e */ "SBC (IX+%2h)",
    /* 0x9f */ ILLINST,
    /* 0xa0 */ ILLINST,
    /* 0xa1 */ ILLINST,
    /* 0xa2 */ ILLINST,
    /* 0xa3 */ ILLINST,
    /* 0xa4 */ ILLINST,
    /* 0xa5 */ ILLINST,
    /* 0xa6 */ "AND (IX+%2h)",
    /* 0xa7 */ ILLINST,
    /* 0xa8 */ ILLINST,
    /* 0xa9 */ ILLINST,
    /* 0xaa */ ILLINST,
    /* 0xab */ ILLINST,
    /* 0xac */ ILLINST,
    /* 0xad */ "XOR IXl",
    /* 0xae */ "XOR (IX+%2h)",
    /* 0xaf */ ILLINST,
    /* 0xb0 */ ILLINST,
    /* 0xb1 */ ILLINST,
    /* 0xb2 */ ILLINST,
    /* 0xb3 */ ILLINST,
    /* 0xb4 */ ILLINST,
    /* 0xb5 */ "OR IXl",
    /* 0xb6 */ "OR (IX+%2h)",
    /* 0xb7 */ ILLINST,
    /* 0xb8 */ ILLINST,
    /* 0xb9 */ ILLINST,
    /* 0xba */ ILLINST,
    /* 0xbb */ ILLINST,
    /* 0xbc */ ILLINST,
    /* 0xbd */ "CP IXl",
    /* 0xbe */ "CP (IX+%2h)",
    /* 0xbf */ ILLINST,
    /* 0xc0 */ ILLINST,
    /* 0xc1 */ ILLINST,
    /* 0xc2 */ ILLINST,
    /* 0xc3 */ ILLINST,
    /* 0xc4 */ ILLINST,
    /* 0xc5 */ ILLINST,
    /* 0xc6 */ ILLINST,
    /* 0xc7 */ "RST 00h",
    /* 0xc8 */ ILLINST,
    /* 0xc9 */ ILLINST,
    /* 0xca */ ILLINST,
    /* 0xcb */ ILLINST,
    /* 0xcc */ ILLINST,
    /* 0xcd */ ILLINST,
    /* 0xce */ ILLINST,
    /* 0xcf */ "RST 08h",
    /* 0xd0 */ ILLINST,
    /* 0xd1 */ ILLINST,
    /* 0xd2 */ ILLINST,
    /* 0xd3 */ ILLINST,
    /* 0xd4 */ ILLINST,
    /* 0xd5 */ ILLINST,
    /* 0xd6 */ ILLINST,
    /* 0xd7 */ "RST 10h",
    /* 0xd8 */ ILLINST,
    /* 0xd9 */ ILLINST,
    /* 0xda */ ILLINST,
    /* 0xdb */ ILLINST,
    /* 0xdc */ ILLINST,
    /* 0xdd */ ILLINST,
    /* 0xde */ ILLINST,
    /* 0xdf */ "RST 18h",
    /* 0xe0 */ ILLINST,
    /* 0xe1 */ "POP IX",
    /* 0xe2 */ ILLINST,
    /* 0xe3 */ "EX IX,(SP)",
    /* 0xe4 */ ILLINST,
    /* 0xe5 */ "PUSH IX",
    /* 0xe6 */ ILLINST,
    /* 0xe7 */ "RST 20h",
    /* 0xe8 */ ILLINST,
    /* 0xe9 */ "LD PC,IX",
    /* 0xea */ ILLINST,
    /* 0xeb */ "EX DE,IX",
    /* 0xec */ ILLINST,
    /* 0xed */ ILLINST,
    /* 0xee */ ILLINST,
    /* 0xef */ "RST 28h",
    /* 0xf0 */ ILLINST,
    /* 0xf1 */ ILLINST,
    /* 0xf2 */ ILLINST,
    /* 0xf3 */ ILLINST,
    /* 0xf4 */ ILLINST,
    /* 0xf5 */ ILLINST,
    /* 0xf6 */ ILLINST,
    /* 0xf7 */ "RST 30h",
    /* 0xf8 */ ILLINST,
    /* 0xf9 */ "LD SP,IX",
    /* 0xfa */ ILLINST,
    /* 0xfb */ ILLINST,
    /* 0xfc */ ILLINST,
    /* 0xfd */ ILLINST,
    /* 0xfe */ ILLINST,
    /* 0xff */ "RST 38h"
  };

char * Z80_DisasmED[256] =
  {
    /* 0x00 */ ILLINST,
    /* 0x01 */ ILLINST,
    /* 0x02 */ ILLINST,
    /* 0x03 */ ILLINST,
    /* 0x04 */ ILLINST,
    /* 0x05 */ ILLINST,
    /* 0x06 */ ILLINST,
    /* 0x07 */ ILLINST,
    /* 0x08 */ ILLINST,
    /* 0x09 */ ILLINST,
    /* 0x0a */ ILLINST,
    /* 0x0b */ ILLINST,
    /* 0x0c */ ILLINST,
    /* 0x0d */ ILLINST,
    /* 0x0e */ ILLINST,
    /* 0x0f */ ILLINST,
    /* 0x10 */ ILLINST,
    /* 0x11 */ ILLINST,
    /* 0x12 */ ILLINST,
    /* 0x13 */ ILLINST,
    /* 0x14 */ ILLINST,
    /* 0x15 */ ILLINST,
    /* 0x16 */ ILLINST,
    /* 0x17 */ ILLINST,
    /* 0x18 */ ILLINST,
    /* 0x19 */ ILLINST,
    /* 0x1a */ ILLINST,
    /* 0x1b */ ILLINST,
    /* 0x1c */ ILLINST,
    /* 0x1d */ ILLINST,
    /* 0x1e */ ILLINST,
    /* 0x1f */ ILLINST,
    /* 0x20 */ ILLINST,
    /* 0x21 */ ILLINST,
    /* 0x22 */ ILLINST,
    /* 0x23 */ ILLINST,
    /* 0x24 */ ILLINST,
    /* 0x25 */ ILLINST,
    /* 0x26 */ ILLINST,
    /* 0x27 */ ILLINST,
    /* 0x28 */ ILLINST,
    /* 0x29 */ ILLINST,
    /* 0x2a */ ILLINST,
    /* 0x2b */ ILLINST,
    /* 0x2c */ ILLINST,
    /* 0x2d */ ILLINST,
    /* 0x2e */ ILLINST,
    /* 0x2f */ ILLINST,
    /* 0x30 */ ILLINST,
    /* 0x31 */ ILLINST,
    /* 0x32 */ ILLINST,
    /* 0x33 */ ILLINST,
    /* 0x34 */ ILLINST,
    /* 0x35 */ ILLINST,
    /* 0x36 */ ILLINST,
    /* 0x37 */ ILLINST,
    /* 0x38 */ ILLINST,
    /* 0x39 */ ILLINST,
    /* 0x3a */ ILLINST,
    /* 0x3b */ ILLINST,
    /* 0x3c */ ILLINST,
    /* 0x3d */ ILLINST,
    /* 0x3e */ ILLINST,
    /* 0x3f */ ILLINST,
    /* 0x40 */ "IN B,(C)",
    /* 0x41 */ "OUT (C),B",
    /* 0x42 */ "SBC HL,BC",
    /* 0x43 */ "LD (%3%2h),BC",
    /* 0x44 */ "NEG",
    /* 0x45 */ "RETN",
    /* 0x46 */ "IM 0",
    /* 0x47 */ "LD I,A",
    /* 0x48 */ "IN C,(C)",
    /* 0x49 */ "OUT (C),C",
    /* 0x4a */ "ADC HL,BC",
    /* 0x4b */ "LD BC,(%3%2h)",
    /* 0x4c */ ILLINST,
    /* 0x4d */ "RETI",
    /* 0x4e */ ILLINST,
    /* 0x4f */ "LD R,A",
    /* 0x50 */ "IN D,(C)",
    /* 0x51 */ "OUT (C),D",
    /* 0x52 */ "SBC HL,DE",
    /* 0x53 */ "LD (%3%2h),DE",
    /* 0x54 */ ILLINST,
    /* 0x55 */ ILLINST,
    /* 0x56 */ "IM 1",
    /* 0x57 */ "LD A,I",
    /* 0x58 */ "IN E,(C)",
    /* 0x59 */ "OUT (C),E",
    /* 0x5a */ "ADC HL,DE",
    /* 0x5b */ "LD DE,(%3%2h)",
    /* 0x5c */ ILLINST,
    /* 0x5d */ ILLINST,
    /* 0x5e */ "IM 2",
    /* 0x5f */ "LD A,R",
    /* 0x60 */ "IN H,(C)",
    /* 0x61 */ "OUT (C),H",
    /* 0x62 */ "SBC HL,HL",
    /* 0x63 */ "LD (%3%2h),HL",
    /* 0x64 */ ILLINST,
    /* 0x65 */ ILLINST,
    /* 0x66 */ ILLINST,
    /* 0x67 */ "RRD",
    /* 0x68 */ "IN L,(C)",
    /* 0x69 */ "OUT (C),L",
    /* 0x6a */ "ADC HL,HL",
    /* 0x6b */ "LD HL,(%3%2h)",
    /* 0x6c */ ILLINST,
    /* 0x6d */ ILLINST,
    /* 0x6e */ ILLINST,
    /* 0x6f */ "RLD",
    /* 0x70 */ "IN (C)",
    /* 0x71 */ ILLINST,
    /* 0x72 */ "SBC HL,SP",
    /* 0x73 */ "LD (%3%2h),SP",
    /* 0x74 */ ILLINST,
    /* 0x75 */ ILLINST,
    /* 0x76 */ ILLINST,
    /* 0x77 */ ILLINST,
    /* 0x78 */ "IN A,(C)",
    /* 0x79 */ "OUT (C),A",
    /* 0x7a */ "ADC HL,SP",
    /* 0x7b */ "LD SP,(%3%2h)",
    /* 0x7c */ ILLINST,
    /* 0x7d */ ILLINST,
    /* 0x7e */ ILLINST,
    /* 0x7f */ ILLINST,
    /* 0x80 */ ILLINST,
    /* 0x81 */ ILLINST,
    /* 0x82 */ ILLINST,
    /* 0x83 */ ILLINST,
    /* 0x84 */ ILLINST,
    /* 0x85 */ ILLINST,
    /* 0x86 */ ILLINST,
    /* 0x87 */ ILLINST,
    /* 0x88 */ ILLINST,
    /* 0x89 */ ILLINST,
    /* 0x8a */ ILLINST,
    /* 0x8b */ ILLINST,
    /* 0x8c */ ILLINST,
    /* 0x8d */ ILLINST,
    /* 0x8e */ ILLINST,
    /* 0x8f */ ILLINST,
    /* 0x90 */ ILLINST,
    /* 0x91 */ ILLINST,
    /* 0x92 */ ILLINST,
    /* 0x93 */ ILLINST,
    /* 0x94 */ ILLINST,
    /* 0x95 */ ILLINST,
    /* 0x96 */ ILLINST,
    /* 0x97 */ ILLINST,
    /* 0x98 */ ILLINST,
    /* 0x99 */ ILLINST,
    /* 0x9a */ ILLINST,
    /* 0x9b */ ILLINST,
    /* 0x9c */ ILLINST,
    /* 0x9d */ ILLINST,
    /* 0x9e */ ILLINST,
    /* 0x9f */ ILLINST,
    /* 0xa0 */ "LDI",
    /* 0xa1 */ "CPI",
    /* 0xa2 */ "INI",
    /* 0xa3 */ "OUTI",
    /* 0xa4 */ ILLINST,
    /* 0xa5 */ ILLINST,
    /* 0xa6 */ ILLINST,
    /* 0xa7 */ ILLINST,
    /* 0xa8 */ "LDD",
    /* 0xa9 */ "CPD",
    /* 0xaa */ "IND",
    /* 0xab */ "OUTD",
    /* 0xac */ ILLINST,
    /* 0xad */ ILLINST,
    /* 0xae */ ILLINST,
    /* 0xaf */ ILLINST,
    /* 0xb0 */ "LDIR",
    /* 0xb1 */ "CPIR",
    /* 0xb2 */ "INIR",
    /* 0xb3 */ "OTIR",
    /* 0xb4 */ ILLINST,
    /* 0xb5 */ ILLINST,
    /* 0xb6 */ ILLINST,
    /* 0xb7 */ ILLINST,
    /* 0xb8 */ "LDDR",
    /* 0xb9 */ "CPDR",
    /* 0xba */ "INDR",
    /* 0xbb */ "OTDR",
    /* 0xbc */ ILLINST,
    /* 0xbd */ ILLINST,
    /* 0xbe */ ILLINST,
    /* 0xbf */ ILLINST,
    /* 0xc0 */ ILLINST,
    /* 0xc1 */ ILLINST,
    /* 0xc2 */ ILLINST,
    /* 0xc3 */ ILLINST,
    /* 0xc4 */ ILLINST,
    /* 0xc5 */ ILLINST,
    /* 0xc6 */ ILLINST,
    /* 0xc7 */ ILLINST,
    /* 0xc8 */ ILLINST,
    /* 0xc9 */ ILLINST,
    /* 0xca */ ILLINST,
    /* 0xcb */ ILLINST,
    /* 0xcc */ ILLINST,
    /* 0xcd */ ILLINST,
    /* 0xce */ ILLINST,
    /* 0xcf */ ILLINST,
    /* 0xd0 */ ILLINST,
    /* 0xd1 */ ILLINST,
    /* 0xd2 */ ILLINST,
    /* 0xd3 */ ILLINST,
    /* 0xd4 */ ILLINST,
    /* 0xd5 */ ILLINST,
    /* 0xd6 */ ILLINST,
    /* 0xd7 */ ILLINST,
    /* 0xd8 */ ILLINST,
    /* 0xd9 */ ILLINST,
    /* 0xda */ ILLINST,
    /* 0xdb */ ILLINST,
    /* 0xdc */ ILLINST,
    /* 0xdd */ ILLINST,
    /* 0xde */ ILLINST,
    /* 0xdf */ ILLINST,
    /* 0xe0 */ ILLINST,
    /* 0xe1 */ ILLINST,
    /* 0xe2 */ ILLINST,
    /* 0xe3 */ ILLINST,
    /* 0xe4 */ ILLINST,
    /* 0xe5 */ ILLINST,
    /* 0xe6 */ ILLINST,
    /* 0xe7 */ ILLINST,
    /* 0xe8 */ ILLINST,
    /* 0xe9 */ ILLINST,
    /* 0xea */ ILLINST,
    /* 0xeb */ ILLINST,
    /* 0xec */ ILLINST,
    /* 0xed */ ILLINST,
    /* 0xee */ ILLINST,
    /* 0xef */ ILLINST,
    /* 0xf0 */ ILLINST,
    /* 0xf1 */ ILLINST,
    /* 0xf2 */ ILLINST,
    /* 0xf3 */ ILLINST,
    /* 0xf4 */ ILLINST,
    /* 0xf5 */ ILLINST,
    /* 0xf6 */ ILLINST,
    /* 0xf7 */ ILLINST,
    /* 0xf8 */ ILLINST,
    /* 0xf9 */ ILLINST,
    /* 0xfa */ ILLINST,
    /* 0xfb */ ILLINST,
    /* 0xfc */ ILLINST,
    /* 0xfd */ ILLINST,
    /* 0xfe */ ILLINST,
    /* 0xff */ ILLINST
  };

char * Z80_DisasmFDCB[256] = /* IY */
  {
    /* 0x00 */ ILLINST,
    /* 0x01 */ ILLINST,
    /* 0x02 */ ILLINST,
    /* 0x03 */ ILLINST,
    /* 0x04 */ ILLINST,
    /* 0x05 */ ILLINST,
    /* 0x06 */ "RLC (IY+%2h)",
    /* 0x07 */ ILLINST,
    /* 0x08 */ ILLINST,
    /* 0x09 */ ILLINST,
    /* 0x0a */ ILLINST,
    /* 0x0b */ ILLINST,
    /* 0x0c */ ILLINST,
    /* 0x0d */ ILLINST,
    /* 0x0e */ "RRC (IY+%2h)",
    /* 0x0f */ ILLINST,
    /* 0x10 */ ILLINST,
    /* 0x11 */ ILLINST,
    /* 0x12 */ ILLINST,
    /* 0x13 */ ILLINST,
    /* 0x14 */ ILLINST,
    /* 0x15 */ ILLINST,
    /* 0x16 */ "RL (IY+%2h)",
    /* 0x17 */ ILLINST,
    /* 0x18 */ ILLINST,
    /* 0x19 */ ILLINST,
    /* 0x1a */ ILLINST,
    /* 0x1b */ ILLINST,
    /* 0x1c */ ILLINST,
    /* 0x1d */ ILLINST,
    /* 0x1e */ "RR (IY+%2h)",
    /* 0x1f */ ILLINST,
    /* 0x20 */ ILLINST,
    /* 0x21 */ ILLINST,
    /* 0x22 */ ILLINST,
    /* 0x23 */ ILLINST,
    /* 0x24 */ ILLINST,
    /* 0x25 */ ILLINST,
    /* 0x26 */ "SLA (IY+%2h)",
    /* 0x27 */ ILLINST,
    /* 0x28 */ ILLINST,
    /* 0x29 */ ILLINST,
    /* 0x2a */ ILLINST,
    /* 0x2b */ ILLINST,
    /* 0x2c */ ILLINST,
    /* 0x2d */ ILLINST,
    /* 0x2e */ "SRA (IY+%2h)",
    /* 0x2f */ ILLINST,
    /* 0x30 */ ILLINST,
    /* 0x31 */ ILLINST,
    /* 0x32 */ ILLINST,
    /* 0x33 */ ILLINST,
    /* 0x34 */ ILLINST,
    /* 0x35 */ ILLINST,
    /* 0x36 */ ILLINST,
    /* 0x37 */ ILLINST,
    /* 0x38 */ ILLINST,
    /* 0x39 */ ILLINST,
    /* 0x3a */ ILLINST,
    /* 0x3b */ ILLINST,
    /* 0x3c */ ILLINST,
    /* 0x3d */ ILLINST,
    /* 0x3e */ "SRL (IY+%2h)",
    /* 0x3f */ ILLINST,
    /* 0x40 */ ILLINST,
    /* 0x41 */ ILLINST,
    /* 0x42 */ ILLINST,
    /* 0x43 */ ILLINST,
    /* 0x44 */ ILLINST,
    /* 0x45 */ ILLINST,
    /* 0x46 */ "BIT 0,(IY+%2h)",
    /* 0x47 */ ILLINST,
    /* 0x48 */ ILLINST,
    /* 0x49 */ ILLINST,
    /* 0x4a */ ILLINST,
    /* 0x4b */ ILLINST,
    /* 0x4c */ ILLINST,
    /* 0x4d */ ILLINST,
    /* 0x4e */ "BIT 1,(IY+%2h)",
    /* 0x4f */ ILLINST,
    /* 0x50 */ ILLINST,
    /* 0x51 */ ILLINST,
    /* 0x52 */ ILLINST,
    /* 0x53 */ ILLINST,
    /* 0x54 */ ILLINST,
    /* 0x55 */ ILLINST,
    /* 0x56 */ "BIT 2,(IY+%2h)",
    /* 0x57 */ ILLINST,
    /* 0x58 */ ILLINST,
    /* 0x59 */ ILLINST,
    /* 0x5a */ ILLINST,
    /* 0x5b */ ILLINST,
    /* 0x5c */ ILLINST,
    /* 0x5d */ ILLINST,
    /* 0x5e */ "BIT 3,(IY+%2h)",
    /* 0x5f */ ILLINST,
    /* 0x60 */ ILLINST,
    /* 0x61 */ ILLINST,
    /* 0x62 */ ILLINST,
    /* 0x63 */ ILLINST,
    /* 0x64 */ ILLINST,
    /* 0x65 */ ILLINST,
    /* 0x66 */ "BIT 4,(IY+%2h)",
    /* 0x67 */ ILLINST,
    /* 0x68 */ ILLINST,
    /* 0x69 */ ILLINST,
    /* 0x6a */ ILLINST,
    /* 0x6b */ ILLINST,
    /* 0x6c */ ILLINST,
    /* 0x6d */ ILLINST,
    /* 0x6e */ "BIT 5,(IY+%2h)",
    /* 0x6f */ ILLINST,
    /* 0x70 */ ILLINST,
    /* 0x71 */ ILLINST,
    /* 0x72 */ ILLINST,
    /* 0x73 */ ILLINST,
    /* 0x74 */ ILLINST,
    /* 0x75 */ ILLINST,
    /* 0x76 */ "BIT 6,(IY+%2h)",
    /* 0x77 */ ILLINST,
    /* 0x78 */ ILLINST,
    /* 0x79 */ ILLINST,
    /* 0x7a */ ILLINST,
    /* 0x7b */ ILLINST,
    /* 0x7c */ ILLINST,
    /* 0x7d */ ILLINST,
    /* 0x7e */ "BIT 7,(IY+%2h)",
    /* 0x7f */ ILLINST,
    /* 0x80 */ ILLINST,
    /* 0x81 */ ILLINST,
    /* 0x82 */ ILLINST,
    /* 0x83 */ ILLINST,
    /* 0x84 */ ILLINST,
    /* 0x85 */ ILLINST,
    /* 0x86 */ "RES 0,(IY+%2h)",
    /* 0x87 */ ILLINST,
    /* 0x88 */ ILLINST,
    /* 0x89 */ ILLINST,
    /* 0x8a */ ILLINST,
    /* 0x8b */ ILLINST,
    /* 0x8c */ ILLINST,
    /* 0x8d */ ILLINST,
    /* 0x8e */ "RES 1,(IY+%2h)",
    /* 0x8f */ ILLINST,
    /* 0x90 */ ILLINST,
    /* 0x91 */ ILLINST,
    /* 0x92 */ ILLINST,
    /* 0x93 */ ILLINST,
    /* 0x94 */ ILLINST,
    /* 0x95 */ ILLINST,
    /* 0x96 */ "RES 2,(IY+%2h)",
    /* 0x97 */ ILLINST,
    /* 0x98 */ ILLINST,
    /* 0x99 */ ILLINST,
    /* 0x9a */ ILLINST,
    /* 0x9b */ ILLINST,
    /* 0x9c */ ILLINST,
    /* 0x9d */ ILLINST,
    /* 0x9e */ "RES 3,(IY+%2h)",
    /* 0x9f */ ILLINST,
    /* 0xa0 */ ILLINST,
    /* 0xa1 */ ILLINST,
    /* 0xa2 */ ILLINST,
    /* 0xa3 */ ILLINST,
    /* 0xa4 */ ILLINST,
    /* 0xa5 */ ILLINST,
    /* 0xa6 */ "RES 4,(IY+%2h)",
    /* 0xa7 */ ILLINST,
    /* 0xa8 */ ILLINST,
    /* 0xa9 */ ILLINST,
    /* 0xaa */ ILLINST,
    /* 0xab */ ILLINST,
    /* 0xac */ ILLINST,
    /* 0xad */ ILLINST,
    /* 0xae */ "RES 5,(IY+%2h)",
    /* 0xaf */ ILLINST,
    /* 0xb0 */ ILLINST,
    /* 0xb1 */ ILLINST,
    /* 0xb2 */ ILLINST,
    /* 0xb3 */ ILLINST,
    /* 0xb4 */ ILLINST,
    /* 0xb5 */ ILLINST,
    /* 0xb6 */ "RES 6,(IY+%2h)",
    /* 0xb7 */ ILLINST,
    /* 0xb8 */ ILLINST,
    /* 0xb9 */ ILLINST,
    /* 0xba */ ILLINST,
    /* 0xbb */ ILLINST,
    /* 0xbc */ ILLINST,
    /* 0xbd */ ILLINST,
    /* 0xbe */ "RES 7,(IY+%2h)",
    /* 0xbf */ ILLINST,
    /* 0xc0 */ ILLINST,
    /* 0xc1 */ ILLINST,
    /* 0xc2 */ ILLINST,
    /* 0xc3 */ ILLINST,
    /* 0xc4 */ ILLINST,
    /* 0xc5 */ ILLINST,
    /* 0xc6 */ "SET 0,(IY+%2h)",
    /* 0xc7 */ ILLINST,
    /* 0xc8 */ ILLINST,
    /* 0xc9 */ ILLINST,
    /* 0xca */ ILLINST,
    /* 0xcb */ ILLINST,
    /* 0xcc */ ILLINST,
    /* 0xcd */ ILLINST,
    /* 0xce */ "SET 1,(IY+%2h)",
    /* 0xcf */ ILLINST,
    /* 0xd0 */ ILLINST,
    /* 0xd1 */ ILLINST,
    /* 0xd2 */ ILLINST,
    /* 0xd3 */ ILLINST,
    /* 0xd4 */ ILLINST,
    /* 0xd5 */ ILLINST,
    /* 0xd6 */ "SET 2,(IY+%2h)",
    /* 0xd7 */ ILLINST,
    /* 0xd8 */ ILLINST,
    /* 0xd9 */ ILLINST,
    /* 0xda */ ILLINST,
    /* 0xdb */ ILLINST,
    /* 0xdc */ ILLINST,
    /* 0xdd */ ILLINST,
    /* 0xde */ "SET 3,(IY+%2h)",
    /* 0xdf */ ILLINST,
    /* 0xe0 */ ILLINST,
    /* 0xe1 */ ILLINST,
    /* 0xe2 */ ILLINST,
    /* 0xe3 */ ILLINST,
    /* 0xe4 */ ILLINST,
    /* 0xe5 */ ILLINST,
    /* 0xe6 */ "SET 4,(IY+%2h)",
    /* 0xe7 */ ILLINST,
    /* 0xe8 */ ILLINST,
    /* 0xe9 */ ILLINST,
    /* 0xea */ ILLINST,
    /* 0xeb */ ILLINST,
    /* 0xec */ ILLINST,
    /* 0xed */ ILLINST,
    /* 0xee */ "SET 5,(IY+%2h)",
    /* 0xef */ ILLINST,
    /* 0xf0 */ ILLINST,
    /* 0xf1 */ ILLINST,
    /* 0xf2 */ ILLINST,
    /* 0xf3 */ ILLINST,
    /* 0xf4 */ ILLINST,
    /* 0xf5 */ ILLINST,
    /* 0xf6 */ "SET 6,(IY+%2h)",
    /* 0xf7 */ ILLINST,
    /* 0xf8 */ ILLINST,
    /* 0xf9 */ ILLINST,
    /* 0xfa */ ILLINST,
    /* 0xfb */ ILLINST,
    /* 0xfc */ ILLINST,
    /* 0xfd */ ILLINST,
    /* 0xfe */ "SET 7,(IY+%2h)",
    /* 0xff */ ILLINST
  };


char * Z80_DisasmDDCB[256] = /* IX */
  {
    /* 0x00 */ ILLINST,
    /* 0x01 */ ILLINST,
    /* 0x02 */ ILLINST,
    /* 0x03 */ ILLINST,
    /* 0x04 */ ILLINST,
    /* 0x05 */ ILLINST,
    /* 0x06 */ "RLC (IX+%2h)",
    /* 0x07 */ ILLINST,
    /* 0x08 */ ILLINST,
    /* 0x09 */ ILLINST,
    /* 0x0a */ ILLINST,
    /* 0x0b */ ILLINST,
    /* 0x0c */ ILLINST,
    /* 0x0d */ ILLINST,
    /* 0x0e */ "RRC (IX+%2h)",
    /* 0x0f */ ILLINST,
    /* 0x10 */ ILLINST,
    /* 0x11 */ ILLINST,
    /* 0x12 */ ILLINST,
    /* 0x13 */ ILLINST,
    /* 0x14 */ ILLINST,
    /* 0x15 */ ILLINST,
    /* 0x16 */ "RL (IX+%2h)",
    /* 0x17 */ ILLINST,
    /* 0x18 */ ILLINST,
    /* 0x19 */ ILLINST,
    /* 0x1a */ ILLINST,
    /* 0x1b */ ILLINST,
    /* 0x1c */ ILLINST,
    /* 0x1d */ ILLINST,
    /* 0x1e */ "RR (IX+%2h)",
    /* 0x1f */ ILLINST,
    /* 0x20 */ ILLINST,
    /* 0x21 */ ILLINST,
    /* 0x22 */ ILLINST,
    /* 0x23 */ ILLINST,
    /* 0x24 */ ILLINST,
    /* 0x25 */ ILLINST,
    /* 0x26 */ "SLA (IX+%2h)",
    /* 0x27 */ ILLINST,
    /* 0x28 */ ILLINST,
    /* 0x29 */ ILLINST,
    /* 0x2a */ ILLINST,
    /* 0x2b */ ILLINST,
    /* 0x2c */ ILLINST,
    /* 0x2d */ ILLINST,
    /* 0x2e */ "SRA (IX+%2h)",
    /* 0x2f */ ILLINST,
    /* 0x30 */ ILLINST,
    /* 0x31 */ ILLINST,
    /* 0x32 */ ILLINST,
    /* 0x33 */ ILLINST,
    /* 0x34 */ ILLINST,
    /* 0x35 */ ILLINST,
    /* 0x36 */ ILLINST,
    /* 0x37 */ ILLINST,
    /* 0x38 */ ILLINST,
    /* 0x39 */ ILLINST,
    /* 0x3a */ ILLINST,
    /* 0x3b */ ILLINST,
    /* 0x3c */ ILLINST,
    /* 0x3d */ ILLINST,
    /* 0x3e */ "SRL (IX+%2h)",
    /* 0x3f */ ILLINST,
    /* 0x40 */ ILLINST,
    /* 0x41 */ ILLINST,
    /* 0x42 */ ILLINST,
    /* 0x43 */ ILLINST,
    /* 0x44 */ ILLINST,
    /* 0x45 */ ILLINST,
    /* 0x46 */ "BIT 0,(IX+%2h)",
    /* 0x47 */ ILLINST,
    /* 0x48 */ ILLINST,
    /* 0x49 */ ILLINST,
    /* 0x4a */ ILLINST,
    /* 0x4b */ ILLINST,
    /* 0x4c */ ILLINST,
    /* 0x4d */ ILLINST,
    /* 0x4e */ "BIT 1,(IX+%2h)",
    /* 0x4f */ ILLINST,
    /* 0x50 */ ILLINST,
    /* 0x51 */ ILLINST,
    /* 0x52 */ ILLINST,
    /* 0x53 */ ILLINST,
    /* 0x54 */ ILLINST,
    /* 0x55 */ ILLINST,
    /* 0x56 */ "BIT 2,(IX+%2h)",
    /* 0x57 */ ILLINST,
    /* 0x58 */ ILLINST,
    /* 0x59 */ ILLINST,
    /* 0x5a */ ILLINST,
    /* 0x5b */ ILLINST,
    /* 0x5c */ ILLINST,
    /* 0x5d */ ILLINST,
    /* 0x5e */ "BIT 3,(IX+%2h)",
    /* 0x5f */ ILLINST,
    /* 0x60 */ ILLINST,
    /* 0x61 */ ILLINST,
    /* 0x62 */ ILLINST,
    /* 0x63 */ ILLINST,
    /* 0x64 */ ILLINST,
    /* 0x65 */ ILLINST,
    /* 0x66 */ "BIT 4,(IX+%2h)",
    /* 0x67 */ ILLINST,
    /* 0x68 */ ILLINST,
    /* 0x69 */ ILLINST,
    /* 0x6a */ ILLINST,
    /* 0x6b */ ILLINST,
    /* 0x6c */ ILLINST,
    /* 0x6d */ ILLINST,
    /* 0x6e */ "BIT 5,(IX+%2h)",
    /* 0x6f */ ILLINST,
    /* 0x70 */ ILLINST,
    /* 0x71 */ ILLINST,
    /* 0x72 */ ILLINST,
    /* 0x73 */ ILLINST,
    /* 0x74 */ ILLINST,
    /* 0x75 */ ILLINST,
    /* 0x76 */ "BIT 6,(IX+%2h)",
    /* 0x77 */ ILLINST,
    /* 0x78 */ ILLINST,
    /* 0x79 */ ILLINST,
    /* 0x7a */ ILLINST,
    /* 0x7b */ ILLINST,
    /* 0x7c */ ILLINST,
    /* 0x7d */ ILLINST,
    /* 0x7e */ "BIT 7,(IX+%2h)",
    /* 0x7f */ ILLINST,
    /* 0x80 */ ILLINST,
    /* 0x81 */ ILLINST,
    /* 0x82 */ ILLINST,
    /* 0x83 */ ILLINST,
    /* 0x84 */ ILLINST,
    /* 0x85 */ ILLINST,
    /* 0x86 */ "RES 0,(IX+%2h)",
    /* 0x87 */ ILLINST,
    /* 0x88 */ ILLINST,
    /* 0x89 */ ILLINST,
    /* 0x8a */ ILLINST,
    /* 0x8b */ ILLINST,
    /* 0x8c */ ILLINST,
    /* 0x8d */ ILLINST,
    /* 0x8e */ "RES 1,(IX+%2h)",
    /* 0x8f */ ILLINST,
    /* 0x90 */ ILLINST,
    /* 0x91 */ ILLINST,
    /* 0x92 */ ILLINST,
    /* 0x93 */ ILLINST,
    /* 0x94 */ ILLINST,
    /* 0x95 */ ILLINST,
    /* 0x96 */ "RES 2,(IX+%2h)",
    /* 0x97 */ ILLINST,
    /* 0x98 */ ILLINST,
    /* 0x99 */ ILLINST,
    /* 0x9a */ ILLINST,
    /* 0x9b */ ILLINST,
    /* 0x9c */ ILLINST,
    /* 0x9d */ ILLINST,
    /* 0x9e */ "RES 3,(IX+%2h)",
    /* 0x9f */ ILLINST,
    /* 0xa0 */ ILLINST,
    /* 0xa1 */ ILLINST,
    /* 0xa2 */ ILLINST,
    /* 0xa3 */ ILLINST,
    /* 0xa4 */ ILLINST,
    /* 0xa5 */ ILLINST,
    /* 0xa6 */ "RES 4,(IX+%2h)",
    /* 0xa7 */ ILLINST,
    /* 0xa8 */ ILLINST,
    /* 0xa9 */ ILLINST,
    /* 0xaa */ ILLINST,
    /* 0xab */ ILLINST,
    /* 0xac */ ILLINST,
    /* 0xad */ ILLINST,
    /* 0xae */ "RES 5,(IX+%2h)",
    /* 0xaf */ ILLINST,
    /* 0xb0 */ ILLINST,
    /* 0xb1 */ ILLINST,
    /* 0xb2 */ ILLINST,
    /* 0xb3 */ ILLINST,
    /* 0xb4 */ ILLINST,
    /* 0xb5 */ ILLINST,
    /* 0xb6 */ "RES 6,(IX+%2h)",
    /* 0xb7 */ ILLINST,
    /* 0xb8 */ ILLINST,
    /* 0xb9 */ ILLINST,
    /* 0xba */ ILLINST,
    /* 0xbb */ ILLINST,
    /* 0xbc */ ILLINST,
    /* 0xbd */ ILLINST,
    /* 0xbe */ "RES 7,(IX+%2h)",
    /* 0xbf */ ILLINST,
    /* 0xc0 */ ILLINST,
    /* 0xc1 */ ILLINST,
    /* 0xc2 */ ILLINST,
    /* 0xc3 */ ILLINST,
    /* 0xc4 */ ILLINST,
    /* 0xc5 */ ILLINST,
    /* 0xc6 */ "SET 0,(IX+%2h)",
    /* 0xc7 */ ILLINST,
    /* 0xc8 */ ILLINST,
    /* 0xc9 */ ILLINST,
    /* 0xca */ ILLINST,
    /* 0xcb */ ILLINST,
    /* 0xcc */ ILLINST,
    /* 0xcd */ ILLINST,
    /* 0xce */ "SET 1,(IX+%2h)",
    /* 0xcf */ ILLINST,
    /* 0xd0 */ ILLINST,
    /* 0xd1 */ ILLINST,
    /* 0xd2 */ ILLINST,
    /* 0xd3 */ ILLINST,
    /* 0xd4 */ ILLINST,
    /* 0xd5 */ ILLINST,
    /* 0xd6 */ "SET 2,(IX+%2h)",
    /* 0xd7 */ ILLINST,
    /* 0xd8 */ ILLINST,
    /* 0xd9 */ ILLINST,
    /* 0xda */ ILLINST,
    /* 0xdb */ ILLINST,
    /* 0xdc */ ILLINST,
    /* 0xdd */ ILLINST,
    /* 0xde */ "SET 3,(IX+%2h)",
    /* 0xdf */ ILLINST,
    /* 0xe0 */ ILLINST,
    /* 0xe1 */ ILLINST,
    /* 0xe2 */ ILLINST,
    /* 0xe3 */ ILLINST,
    /* 0xe4 */ ILLINST,
    /* 0xe5 */ ILLINST,
    /* 0xe6 */ "SET 4,(IX+%2h)",
    /* 0xe7 */ ILLINST,
    /* 0xe8 */ ILLINST,
    /* 0xe9 */ ILLINST,
    /* 0xea */ ILLINST,
    /* 0xeb */ ILLINST,
    /* 0xec */ ILLINST,
    /* 0xed */ ILLINST,
    /* 0xee */ "SET 5,(IX+%2h)",
    /* 0xef */ ILLINST,
    /* 0xf0 */ ILLINST,
    /* 0xf1 */ ILLINST,
    /* 0xf2 */ ILLINST,
    /* 0xf3 */ ILLINST,
    /* 0xf4 */ ILLINST,
    /* 0xf5 */ ILLINST,
    /* 0xf6 */ "SET 6,(IX+%2h)",
    /* 0xf7 */ ILLINST,
    /* 0xf8 */ ILLINST,
    /* 0xf9 */ ILLINST,
    /* 0xfa */ ILLINST,
    /* 0xfb */ ILLINST,
    /* 0xfc */ ILLINST,
    /* 0xfd */ ILLINST,
    /* 0xfe */ "SET 7,(IX+%2h)",
    /* 0xff */ ILLINST
  };
